//***************************************************************
//*	  					  buban101.cpp						    *
//*	    			      aaawen 2005.09.08						*
//***************************************************************
//_DEBUG_MSG_,_OS_WINDOWS_DEBUG_
#ifdef OS_LINUX
#include "baohulib/commport.h"
#include "baohulib/serialport.h"
#else
#include "commport.h"
#include "udpcomm.h"
#include "display.h"
#endif
#include <math.h>
#include <time.h>
#include "buban101.h"
#include "scadaprotect.h"

extern SIO_PARAM_DEF    SioParam[];
extern FUNCTION_CALL	*FunCallPtr;
extern	void			*pvconf_handle;
extern	void			*pvportconf_handle;
extern  void			*pvdataconf_handle;
extern  char			pvDataFileName[256];
extern  char			IniFilePath[256];

const char  *gpStrBuban101Cmd[BUBAN101_TIMER_CMD_NUM] = 
{
			"ٻ",
			"ٻʼ"
};

/*!
	֯ṹ:·()+װ
*/
char *gpStrBuban101ConfigInfo[] =
{ 
	" ; ***** 101Լ *****",
	" ",
	" ; ٻھΪλ",
	" վַ = 1                ; ȱʡ= 0 ",
	" ƽʽͨѶ = 0            ; ȱʡ= 0 ",
	" ٻ = 120",
	" ٻʼ = 300",
	" ʱʱ = 20.0",
	" ңطʽ=0",
	" ; =0˫ң(ȱʡ)=1ңء",
	" ",
	"ңϢʼַ=0x701",
	"ңϢʼַ=0x001",
	"ңϢʼַ=0xC01",
	"ңϢʼַ=0xB01",
	" ;Ϣַ,ȱʡֵΪ97沿101涨ֵ",
	" ", 
	" 汾 = 1",
	" ;=0 buban101(ȱʡֵ); =1 IEC_870_5_101Լ",
	" ;ע:ת֧Buban101Լ",
	" ",
	"*******101Լ*******",
	"",	// ־(м䲻ܺиÿַ)
};

//********************************************************************
//*						   ȡú	        			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void Buban101ReadConfig(int commid)
{
	int     i;
	char	szSection[128], szbuf[128];
	char    szPortConfig[256];
	pBUBAN101PORTPARAM pPortParam;

#ifdef OS_LINUX
    strcpy(szPortConfig, "portconfig.ini");
#else
    //GetCurrentDirectory(sizeof(szDir), szDir);
	sprintf(szPortConfig, "%s/portconfig.ini", IniFilePath);
#endif

	SioParam[commid].ExtInfo = HEAP_MALLOC(sizeof(BUBAN101PORTPARAM));

	if(!SioParam[commid].ExtInfo)
	{
		sprintf(szbuf, "WARN(%04d): commid_%02d ExtInfo=malloc(%d) failed.\n", 
			getpid(), commid, sizeof(BUBAN101PORTPARAM));
		DebugPrint(szbuf);
		return;
	}

	memset(SioParam[commid].ExtInfo, 0, sizeof(BUBAN101PORTPARAM));        

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;

	/* ֻSioParam[commid].m_psBaoHuǿʱŻе */
	pPortParam->m_psBaoHu = SioParam[commid].m_psBaoHu;

	sprintf(szSection, "Port%d", commid+1);

	if(GetPrivateProString(szSection, "վַ", "0", szbuf, 120, szPortConfig) > 0)
	{
		pPortParam->LinkAddr = atoi(szbuf);
	}
	if(GetPrivateProString(szSection, "ƽʽͨѶ", "0", szbuf, 120, szPortConfig) > 0)
	{
		pPortParam->BalanceOrNot = atoi(szbuf);
	}
	if(GetPrivateProString(szSection, "ңطʽ", "0", szbuf, 120, szPortConfig) > 0)
	{
		pPortParam->YkMode = atoi(szbuf);
	}
	if(GetPrivateProString(szSection, "ʱʱ", "20.0", szbuf, 120, szPortConfig) > 0)
	{
		pPortParam->lTimeOutConst = (long)(atof(szbuf)*1000/TIMER_CNT);
	}
	pPortParam->RtuVersion = GetPrivateProInt(szSection, "汾", 0, szPortConfig);
	pPortParam->iAiBaseAddr = GetPrivateProInt(szSection, "ңϢʼַ", INFO_AI_BASEADDR, szPortConfig);
	pPortParam->iDiBaseAddr = GetPrivateProInt(szSection, "ңϢʼַ", INFO_DI_BASEADDR, szPortConfig);
	pPortParam->iPiBaseAddr = GetPrivateProInt(szSection, "ңϢʼַ", INFO_PI_BASEADDR, szPortConfig);
	pPortParam->iYkBaseAddr = GetPrivateProInt(szSection, "ңϢʼַ", INFO_YKYT_BASEADDR, szPortConfig);

	// ѯָ
	for(i=0; i<BUBAN101_TIMER_CMD_NUM; i++)
	{
		GetPrivateProString(szSection, (char *)gpStrBuban101Cmd[i], "0", szbuf, 120, szPortConfig);
		pPortParam->CmdTime[i].CmdTimerConst = (long)(atof(szbuf)*1000/TIMER_CNT);
		if(pPortParam->CmdTime[i].CmdTimerConst > 5)
		{
			pPortParam->CmdTime[i].CmdTimerCnt = pPortParam->CmdTime[i].CmdTimerConst - 5;
		}
	}
	
	InitBuban101CommandBuffer(commid);
}

//********************************************************************
//*						  ȡ˿ݺ        			         *
//*int commid     : ˿ں                                     *
//*      u_char buf     : Դָ                           *
//*      int len        : Դ                                 *
//********************************************************************
void Buban101RecvData(int commid, u_char *buf, int len)// Լݴ
{
	int    i;
	pBUBAN101PORTPARAM pPortParam;
#ifdef _DEBUG_MSG_
	char   szbuf[256];
#endif

	if(!IsExtInfoPtr(commid))
		return;
	
	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;

	// wen 2005.09.12 ݽ,ոλ
	if(len > 0)
	{
		pPortParam->LinkOkCnt = 0;
	}

	for(i=0; i<len; i++)
	{
		switch(pPortParam->m_psBaoHu->m_iRevStatus)
		{
			case 0:// 0x10 / 0x68
				pPortParam->m_iRecvLen = 0;				
				if(buf[i] == 0x10)
				{
					pPortParam->m_psBaoHu->m_iRevStatus = 4;
					pPortParam->m_psBaoHu->m_iNeedRevLength = 4;
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				}
				else if(buf[i] == 0x68)
				{
					pPortParam->m_psBaoHu->m_iRevStatus++;
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				}
				else if(buf[i] == 0xE5)
				{
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
					Buban101ProcessData(commid, pPortParam, TRUE);
					//pPortParam->LinkOkCnt = 0;
					pPortParam->m_psBaoHu->RevCmdFlag = 1;
#ifndef OS_LINUX
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					break;
				}
				else
				{
					pPortParam->m_psBaoHu->m_iRevStatus = 5;
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				}
				break;
			case 1:
			case 2:
				pPortParam->m_psBaoHu->m_iRevStatus++;
				pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				break;
			case 3:// ȼ
				if(buf[i] == 0x68)
				{
					if(pPortParam->m_au8RecvBuf[1] != pPortParam->m_au8RecvBuf[2])
					{
						pPortParam->m_psBaoHu->m_iRevStatus=1;
						SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
						Buban101ProcessData(commid, pPortParam, FALSE);
						pPortParam->m_iRecvLen = 0;
						pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
					}
					else
					{
						pPortParam->m_psBaoHu->m_iRevStatus++;
						pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
						pPortParam->m_psBaoHu->m_iNeedRevLength = (BYTE)(pPortParam->m_au8RecvBuf[1])+2;
					}
				}
				else
				{
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
					pPortParam->m_psBaoHu->m_iRevStatus=5;
				}
				break;
			case 4:// ȷ
				pPortParam->m_psBaoHu->m_iNeedRevLength--;
				pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
				if(pPortParam->m_psBaoHu->m_iNeedRevLength > 0)
					break;

				if(buf[i] != 0x16)
				{
					pPortParam->m_psBaoHu->m_iRevStatus=5;
					break;
				}

				if(Buban101Check(pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen) == TRUE)
				{
					Buban101ProcessData(commid, pPortParam, TRUE);
					pPortParam->m_psBaoHu->m_iRevStatus = 0;
					pPortParam->m_psBaoHu->RevCmdFlag = 1;
				}
				else
				{
					SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
					SioParam[commid].LostSyncCnt++;
					pPortParam->m_psBaoHu->m_iRevStatus = 5;
				}
#ifndef OS_LINUX
				if((GetCurPort() == commid) && IsRealDataDisp())
				{
					WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
						(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
				}
#endif
				//pPortParam->LinkOkCnt = 0;
				break;
			case 5:// 
			default:
				//if(buf[i] == 0x16)
				if(buf[i] == 0x10)
				{
#ifndef OS_LINUX
					// wen 2004.11.22 ʾ
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					Buban101ProcessData(commid, pPortParam, FALSE);
					SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
					pPortParam->m_psBaoHu->m_iRevStatus = 4;
					pPortParam->m_psBaoHu->m_iNeedRevLength = 4;
					pPortParam->m_iRecvLen = 1;
					pPortParam->m_au8RecvBuf[0] = buf[i];
				}
				else if(buf[i] == 0x68)
				{
#ifndef OS_LINUX
					// wen 2004.11.22 ʾ
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					Buban101ProcessData(commid, pPortParam, FALSE);
					SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
					pPortParam->m_psBaoHu->m_iRevStatus = 1;
					pPortParam->m_iRecvLen = 1;
					pPortParam->m_au8RecvBuf[0] = buf[i];
				}
				else if((buf[i] == 0x16) || (buf[i] == 0xE5))
				{
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
#ifndef OS_LINUX
					// wen 2004.11.22 ʾ
					if((GetCurPort() == commid) && IsRealDataDisp())
					{
						WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
							(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
					}
#endif
					Buban101ProcessData(commid, pPortParam, FALSE);
					SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
					pPortParam->m_psBaoHu->m_iRevStatus = 0;					
					pPortParam->m_iRecvLen = 0;
				}
				else
				{
					pPortParam->m_au8RecvBuf[pPortParam->m_iRecvLen++] = buf[i];
					if(pPortParam->m_iRecvLen > 200)
					{
#ifndef OS_LINUX
						// wen 2004.11.22 ʾ
						if((GetCurPort() == commid) && IsRealDataDisp())
						{
							WatchDataPutDispBuf(commid, SDS_SIO_RECV_DATA, 
								(BYTE *)pPortParam->m_au8RecvBuf, pPortParam->m_iRecvLen);
						}
#endif
						Buban101ProcessData(commid, pPortParam, FALSE);
						SioParam[commid].ErrMsgNum += pPortParam->m_iRecvLen;
						pPortParam->m_iRecvLen = 0;
					}
				}
				//pPortParam->LinkOkCnt = 0;
				break;
		}
	}

#ifdef _DEBUG_MSG_
	sprintf(szbuf, "wen: commid = %d, send=%d, recv=%d, error=%d, lost=%d\n", commid, 
		SioParam[commid].SendCharNum, SioParam[commid].RecvCharNum, 
		SioParam[commid].ErrMsgNum, SioParam[commid].LostSyncCnt);
	DebugPrint(szbuf);
#endif
}

//********************************************************************
//*						  ʱ        			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void Buban101Timer(int commid)
{
	BUBAN101PORTPARAM	*pPortParam;

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;

	// Ϊת˿ڣ򲻽ѯָɡ
	if(PROTOCOL_SLAVE != pPortParam->m_psBaoHu->PortType)
	{
		if(pPortParam->LinkOk)
		{
			pPortParam->LinkOkCnt++;
			if(pPortParam->LinkOkCnt >= pPortParam->lTimeOutConst)
			{
				InitBuban101CommandBuffer(commid);
				return;
			}
		}
		Buban101FindNextCmd(commid);
	}
	
	Buban101SendCmdFormPollCmdBuf(commid);
}

//********************************************************************
//*						  ңңݴ     			         *
//*int commid     : ˿ں                                     *
//*      u_char buf     : Դָ                           *
//*      int len        : Դ                                 *
//********************************************************************
void Buban101YkYtProcess(int commid, u_char *buf, int len)		// ңң
{
	int				portno, ykytpnt;
	int				iDirect;

	// buf[0] --- ˿ں(=commid)
	// buf[1]
	// buf[2]
	// buf[3]
	// buf[4] --- ص
	// buf[5]
	// buf[6]
	// buf[7]
	// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
	//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
	// buf[9] --- ״̬(1=ֵϣ2=ϵ)
	//                    (λΪ1ʱΪУ, 1=غ, 2=ط, 3=ʧ)
	// תңݵУֻҪתĿصţʵʵĶ˿ںӦǸתĶ˿
	// ת㲢ûָתص㣬صתĵһ¡

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	iDirect = buf[9] & 0x80;
	portno = buf[0]+buf[1]*256+buf[2]*65536+buf[3]*16777216;
	ykytpnt = buf[4]+buf[5]*256+buf[6]*65536+buf[7]*16777216;

	// УϢ(ź)
	if(iDirect)
	{
		Buban101ProvMakeYkYtCommand(commid, buf, len);
	}
	else
	{
		MakeBuBan101YkYtCommand(commid, buf, len);
	}
}

//********************************************************************
//*						  ϵͳ·ʱ        			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void Buban101SendSystemTime(int commid)		// ϵͳʱ
{
	BUBAN101PORTPARAM *pPortParam;

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	if(2 != pPortParam->m_psBaoHu->CheckTime)
	{
		return;
	}

	if(pPortParam->Initdata)
	{
		if(PROTOCOL_SLAVE != pPortParam->m_psBaoHu->PortType)
		{
			MakeBuban101Command(commid, RTU_TIME);
		}
	}
}

//********************************************************************
//*						  ϵͳ˳ʱԼ   			         *
//*int commid     : ˿ں                                     *
//********************************************************************
void Buban101Exit(int commid)
{
	// ͷзڴ
}

// úת˿·ʵװõı
void Buban101BaoHuCmdProcess(int commid, RTUMSG *rtumsg, BOOL bUpData)
{
}

int Buban101GetBaohuDataBase(int commid, int iProvAddr, GROUPDEF **ppBaoHuDB)
{
	return 0;
}
/////////////////////////ͨúӿڽ///////////////////////////////

/////////////////////////buban101ӿ///////////////////////////
// У֡Ƿȷ
BOOL Buban101Check(u_char* msg, int len)
{
	BOOL	bRetval = FALSE;
	int		iCheckLen;
	if( len == 1 )
	{
		if( msg[0] == 0xE5 )
			bRetval = TRUE;
	}
	else
	{
		switch( msg[0] )
		{
			case 0x10: // ֡
				if ( msg[4] != 0x16 )
					break;
				if ( CalBuban101Lpc( &msg[1], 2 ) != msg[3] )
					break;
				bRetval = TRUE;
				break;
			case 0x68: // ֡
				if ( msg[0] != msg[3] )
					break;
				if ( msg[len-1] != 0x16 )
					break;
				if ( msg[1] != msg[2] )
					break;
				iCheckLen = msg[1];
				if ( CalBuban101Lpc( &msg[4], iCheckLen ) != msg[len-2] )
					break;
				bRetval = TRUE;
				break;
			default:
				break;
		}
	}
	return bRetval;
}

// Buban101 ۼӺͼ
u_char CalBuban101Lpc(u_char* msg, int len)
{
	int		i;
    u_char	retval = 0;

    for (i = 0 ; i < len; i++)
		retval += msg[i];
    return retval;
}

//ָʼ
void InitBuban101CommandBuffer(int commid)
{
	pBUBAN101PORTPARAM pPortParam;

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;
	pPortParam->LinkOk = false;
	pPortParam->RstLinkOk = false;
	pPortParam->Initdata = false;
	pPortParam->CtlByte = 0;
	pPortParam->CurCmdIdx = 0;
	pPortParam->LinkOkCnt = 0;

	ClearAllCmdFromPollCmdBuf(commid);
}
/////////////////////////buban101ӿڽ///////////////////////

void Buban101ProvMakeYkYtCommand(int commid, u_char *buf, int len)
{
	// buf[0] --- ˿ں(=commid)
	// buf[1]
	// buf[2]
	// buf[3]
	// buf[4] --- ص
	// buf[5]
	// buf[6]
	// buf[7]
	// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
	//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
	// buf[9] --- ״̬(1=ֵϣ2=ϵ)
	//                    (λΪ1ʱΪУ, 1=غ, 2=ط, 3=ʧ)
	// תңݵУֻҪתĿصţʵʵĶ˿ںӦǸתĶ˿
	// ת㲢ûָתص㣬صתĵһ¡

	int		ykpoint;
    u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
	static int iYkStatus = 0;
	BUBAN101PORTPARAM	*pPortParam;

	if(IsExtInfoPtr(commid) == FALSE)
	{
		return;
	}

	if((buf[9] & 0x80) == 0)
	{
		return;
	}

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;
	
    memset( (char*)commandbuf, 0x00, MAX_POLLCMD_BUF_LEN );
    
	ykpoint = buf[4]+buf[5]*256+buf[6]*65536+buf[7]*16777216;
	ykpoint += pPortParam->iYkBaseAddr - 1;

	switch(buf[8])
    {
        case 1:
        case 4:		// ѡ
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode)
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			if((buf[9] & 0x03) == 0x03)
			{
				commandbuf[8] = 0x47;
			}
			else
			{
				commandbuf[8] = 7;
			}
			commandbuf[9] = pPortParam->LinkAddr;
			
			// wen 2002.11.18 ֽ˳޸
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			if(commandbuf[8] == 0x07)
			{
				if((buf[9] & 0x01) == 1)
				{
					if( commandbuf[6] != 45)
					{
						commandbuf[12] = 0xfc + 2;
						iYkStatus = 2;
					}
					else
					{
						commandbuf[12] = 0xfc + 1;
						iYkStatus = 1;
					}
				}
				else
				{
					if( commandbuf[6] != 45 )
					{
						commandbuf[12] = 0xfc + 1;
						iYkStatus = 1;
					}
					else
					{
						commandbuf[12] = 0xfc;
						iYkStatus = 0;
					}
				}
			}
			commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
		
		case 2:
		case 5:         // ִ
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode )
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			if(buf[9] & 0x01)
			{
				commandbuf[8] = 7;
			}
			else
			{
				commandbuf[8] = 0x47;
			}
			commandbuf[9] = pPortParam->LinkAddr;

			// wen 2002.11.18 ֽ˳޸
			//*(WORD*)&commandbuf[10] = ykpoint;
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			commandbuf[12] = (char)(0x7c + iYkStatus);
			commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
    
		case 3:
		case 6:
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode)
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			if(buf[9] & 0x01)
			{
				commandbuf[8] = 9;
			}
			else
			{
				commandbuf[8] = 0x49;
			}
			commandbuf[9] = pPortParam->LinkAddr;

			// wen 2002.11.18 ֽ˳޸
			//*(WORD*)&commandbuf[10] = ykpoint;
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			commandbuf[12] = (char)(0xfc + iYkStatus);
			commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
	}

	if(ShmGetDispYkYtFlag())
	{
		printf("TIP_(%04d): commid =%d ykytpnt=%d, op=%d checked.\n", 
			getpid(), commid, ykpoint, (buf[9] & 0x7F));
	}
}

//===========================Ϊָɺ=======================
/*!
	\brief ѰҲһ
	\param u_32 portno : RTU˿ں
	\param i_32 iBuIdx : װ
*/
void MakeBuban101Command(u_32 commid, u_char cmdidx)
{
	int					i;
	DAY_TIME			sCurTime;
	char				commandbuf[MAX_POLLCMD_BUF_LEN];
	BUBAN101PORTPARAM	*pPortParam;

	memset( commandbuf, 0, sizeof( commandbuf ) );

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;
	switch ( cmdidx )
    {
		case ASK_LINK:	// ·
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x49;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 5);
			break;

		case RST_LINK:       // λ·
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x40;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 5);
			break;

		case RTU_TIME:	// ʱͬ
			GetLocalTimeEx(&sCurTime);
			commandbuf[0] = 0x68;
			commandbuf[1] = 15;
			commandbuf[2] = 15;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			commandbuf[6] = 103;
			commandbuf[7] = 1;
			commandbuf[8] = 6;
			commandbuf[9] = pPortParam->LinkAddr;
			commandbuf[10] = 0;
			commandbuf[11] = 0;
			sCurTime.mSec = sCurTime.Sec * 1000 + sCurTime.mSec;
			commandbuf[12] = sCurTime.mSec % 256;
			commandbuf[13] = sCurTime.mSec / 256;
			commandbuf[14] = (u_char)sCurTime.Min;
			commandbuf[15] = (u_char)sCurTime.Hour;
			commandbuf[16] = (u_char)sCurTime.Day;
			commandbuf[17] = (u_char)sCurTime.Month;
			commandbuf[18] = (u_char)(sCurTime.Year%100);
			commandbuf[20] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, commandbuf, 21);
			break;

		case ASK_DI_DATA:	// ٻ2YX
			for ( i = 0; i < (pPortParam->m_psBaoHu->DiNum+MAX_GROUP_DINUM-1)/MAX_GROUP_DINUM; i++)
			{
			    commandbuf[0] = 0x68;
				commandbuf[1] = 9;
				commandbuf[2] = 9;
				commandbuf[3] = 0x68;
				commandbuf[4] = 0x5b;
				commandbuf[5] = pPortParam->LinkAddr;
				commandbuf[6] = 100;
				commandbuf[7] = 0;
				commandbuf[8] = 5;
				commandbuf[9] = pPortParam->LinkAddr;
				commandbuf[10] = 0;
				commandbuf[11] = 0;
				commandbuf[12] = 21 + i;
				commandbuf[14] = 0x16;
				PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 15);
			}
			break;

		case ASK_AI_DATA:	// ٻ2YC
			for ( i = 0; i < (pPortParam->m_psBaoHu->AiNum+MAX_GROUP_AINUM-1)/MAX_GROUP_AINUM; i++)
			{
			    commandbuf[0] = 0x68;
				commandbuf[1] = 9;
				commandbuf[2] = 9;
				commandbuf[3] = 0x68;
				commandbuf[4] = 0x5b;
				commandbuf[5] = pPortParam->LinkAddr;
				commandbuf[6] = 100;
				commandbuf[7] = 0;
				commandbuf[8] = 5;
				commandbuf[9] = pPortParam->LinkAddr;
				commandbuf[10] = 0;
				commandbuf[11] = 0;
				commandbuf[12] = 29 + i;
				commandbuf[14] = 0x16;
				PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 15);
			}
			break;

		case ASK_PI_DATA:	// ٻ2YM
			for ( i = 0; i < (pPortParam->m_psBaoHu->PiNum+MAX_GROUP_PINUM-1)/MAX_GROUP_PINUM; i++)
			{
			    commandbuf[0] = 0x68;
				commandbuf[1] = 9;
				commandbuf[2] = 9;
				commandbuf[3] = 0x68;
				commandbuf[4] = 0x5b;
				commandbuf[5] = pPortParam->LinkAddr;
				commandbuf[6] = 101;
				commandbuf[7] = 0;
				commandbuf[8] = 6;
				commandbuf[9] = pPortParam->LinkAddr;
				commandbuf[10] = 0;
				commandbuf[11] = 0;
				if(VER_IEC870_5_101 == pPortParam->RtuVersion)
					commandbuf[12] = 1 + i;
				else
					commandbuf[12] = 2 + i;
				commandbuf[14] = 0x16;
				PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 15);
			}
			break;

		case ASK_PI:		//ٻ
			commandbuf[0] = 0x68;
			commandbuf[1] = 9;
			commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			commandbuf[6] = 101;
			commandbuf[7] = 1;
			commandbuf[8] = 6;
			commandbuf[9] = pPortParam->LinkAddr;
			commandbuf[10] = 0;
			commandbuf[11] = 0;
			if(VER_IEC870_5_101 == pPortParam->RtuVersion)
				commandbuf[12] = 0x45;
			else
				commandbuf[12] = 0x41;
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 15);
			pPortParam->Initdata = FALSE;
			break;

		case ASK_ALL_DATA:// ٻʼ
			commandbuf[0] = 0x68;
			commandbuf[1] = 9;
			commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			commandbuf[6] = 100;
			commandbuf[7] = 1;
			commandbuf[8] = 6;
			commandbuf[9] = pPortParam->LinkAddr;
			commandbuf[10] = 0;
			commandbuf[11] = 0;
			commandbuf[12] = 20;
			commandbuf[14] = 0x16;
		    PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 15);
			pPortParam->Initdata = FALSE;
			break;

		case ASK_SECOND_DATA:// ٻ2
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x5b;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, NORMAL_POLL_CMD, 0, commandbuf, 5);
		    break;

		case ASK_FIRST_DATA:	// ٻ1
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x5a;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, commandbuf, 5);
			break;
		case ACK:				//ȷϻش
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x00;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, commandbuf, 5);
			break;
		case ANS_LINK:
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x0b;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, commandbuf, 5);
			break;
    }
}

//ңңָ
void MakeBuBan101YkYtCommand( u_32 commid, u_char *buf, int len )
{
	// buf[0] --- ˿ں(=commid)
	// buf[1]
	// buf[2]
	// buf[3]
	// buf[4] --- ص
	// buf[5]
	// buf[6]
	// buf[7]
	// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
	//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
	// buf[9] --- ״̬(1=ֵϣ2=ϵ)
	//                    (λΪ1ʱΪУ, 1=ɹ, 0=ʧ)
	// תңݵУֻҪתĿصţʵʵĶ˿ںӦǸתĶ˿
	// ת㲢ûָתص㣬صתĵһ¡

	int		ykpoint;
    u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
	static int iYkStatus = 0;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (pBUBAN101PORTPARAM)SioParam[commid].ExtInfo;
	
    memset( (char*)commandbuf, 0x00, MAX_POLLCMD_BUF_LEN );
    
	ykpoint = buf[4]+buf[5]*256+buf[6]*65536+buf[7]*16777216;
	ykpoint += pPortParam->iYkBaseAddr - 1;

    switch(buf[8])
    {
        case 1:
        case 4:		// ѡ
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode)
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			commandbuf[8] = 6;
			commandbuf[9] = pPortParam->LinkAddr;
			
			// wen 2002.11.18 ֽ˳޸
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			if(buf[9] == 1)
			{
				if( commandbuf[6] != 45 )
				{
					commandbuf[12] = 0xfc + 2;
					iYkStatus = 2;
				}
				else
				{
					commandbuf[12] = 0xfc + 1;
					iYkStatus = 1;
				}
			}
			else
			{
				if( commandbuf[6] != 45 )
				{
					commandbuf[12] = 0xfc + 1;
					iYkStatus = 1;
				}
				else
				{
					commandbuf[12] = 0xfc;
					iYkStatus = 0;
				}
			}
			
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
		
		case 2:
		case 5:         // ִ
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode )
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			commandbuf[8] = 6;
			commandbuf[9] = pPortParam->LinkAddr;

			// wen 2002.11.18 ֽ˳޸
			//*(WORD*)&commandbuf[10] = ykpoint;
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			commandbuf[12] = (char)(0x7c + iYkStatus);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
    
		case 3:
		case 6:
			commandbuf[0] = 0x68;
    	    commandbuf[1] = 9;
    	    commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			switch(pPortParam->YkMode)
			{				
				case CONTROL_SINGAL:		// 
					if(VER_IEC870_5_101 != pPortParam->RtuVersion)
						commandbuf[6] = 46;
					else
						commandbuf[6] = 45;
					break;
				case CONTROL_DOUBLE:		// ˫
				case CONTROL_DIRECT:		// ֱӿ
					commandbuf[6] = 46;//(rtumsg->MsgData[3] == 1) ? 46 : 47;
					break;
			}
			commandbuf[7] = 1;
			commandbuf[8] = 8;
			commandbuf[9] = pPortParam->LinkAddr;

			// wen 2002.11.18 ֽ˳޸
			//*(WORD*)&commandbuf[10] = ykpoint;
			commandbuf[10] = (char)(ykpoint & 0x00ff);
			commandbuf[11] = (char)((ykpoint & 0xff00)>>8);

			commandbuf[12] = (char)(0xfc + iYkStatus);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, INSERT_POLL_CMD, 0, (char *)commandbuf, 15);
			break;
	}

	if(ShmGetDispYkYtFlag())
	{
		printf("TIP_(%04d): commid =%d ykytpnt=%d, op=%d checked.\n", 
			getpid(), commid, ykpoint, (buf[9] & 0x7F));
	}
}

//===================ΪPOLLINGԼ溯ӿ======================
/*!
	\brief ѰҲһ
	\param u_32 portno : RTU˿ں
	\param i_32 iBuIdx : װ
*/
void Buban101FindNextCmd(int commid)
{
	int					i, iCurCmdIdx;
	BUBAN101PORTPARAM	*pPortParam;
	int		framename[BUBAN101_TIMER_CMD_NUM] = 
			{	
//				ASK_DI_DATA, 
//				ASK_AI_DATA,
//				ASK_PI_DATA,
				ASK_PI, 
				ASK_ALL_DATA
			};

	if((commid < 0) || (commid >= GetMaxPort()))
	{
		return;
	}

	if(!ShmGetPortFlag(commid, FLAG_OPEN))
	{
		return;
	}

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(!pPortParam->LinkOk)
	{
		if(CheckPollCmdBufEmpty(commid) <= 0)
		{
			return;
		}

		if(!pPortParam->RstLinkOk)
		{
			InitBuban101CommandBuffer(commid);
			MakeBuban101Command(commid, ASK_LINK);
		}
		else
		{
			pPortParam->LinkOkCnt++;
			if(pPortParam->LinkOkCnt >= pPortParam->lTimeOutConst)
			{
				pPortParam->LinkOkCnt = 0;
				pPortParam->RstLinkOk = false;
			}
		}
		return;
	}

	for(i = 0; i < BUBAN101_TIMER_CMD_NUM; i++)
	{
		if(pPortParam->CmdTime[i].CmdTimerConst )
			pPortParam->CmdTime[i].CmdTimerCnt++;
	}

	if(CheckPollCmdBufEmpty(commid) <= 0)
	{
		return;
	}

	if (!pPortParam->Initdata )
	{
		// IEC-870-5-101ж֡ѯ
		//ҴĶIEC101Ҫٻڼ䲻
		//if(VER_IEC870_5_101 == pPortParam->RtuVersion)
		//	MakeBuban101Command( port, ASK_SECOND_DATA );
		return;
	}
	
	iCurCmdIdx = pPortParam->CurCmdIdx;
	for ( i = 0; i < BUBAN101_TIMER_CMD_NUM; i++ )
	{		
		iCurCmdIdx = (iCurCmdIdx+1) % BUBAN101_TIMER_CMD_NUM;
		if ( (pPortParam->CmdTime[iCurCmdIdx].CmdTimerCnt 
				>= pPortParam->CmdTime[iCurCmdIdx].CmdTimerConst)				
				&& ( pPortParam->CmdTime[iCurCmdIdx].CmdTimerConst > 0 ))
			{
				pPortParam->CurCmdIdx = iCurCmdIdx;
				MakeBuban101Command(commid, framename[iCurCmdIdx]);
				pPortParam->CmdTime[iCurCmdIdx].CmdTimerCnt = 0;
				return;
			}
	}

	MakeBuban101Command(commid, ASK_SECOND_DATA);
}

BOOL Buban101FindNextCmdEx(int commid)
{
	BOOL				bRetVal;
	int					i, iCurCmdIdx;
	BUBAN101PORTPARAM	*pPortParam;
	int		framename[BUBAN101_TIMER_CMD_NUM] = 
			{	
//				ASK_DI_DATA, 
//				ASK_AI_DATA,
//				ASK_PI_DATA,
				ASK_PI, 
				ASK_ALL_DATA
			};

	bRetVal = FALSE;
	if((commid < 0) || (commid >= GetMaxPort()))
	{
		return bRetVal;
	}

	if(!ShmGetPortFlag(commid, FLAG_OPEN))
	{
		return bRetVal;
	}

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(!pPortParam->LinkOk)
	{
		if(CheckPollCmdBufEmpty(commid) <= 0)
		{
			return bRetVal;
		}

		if(!pPortParam->RstLinkOk)
		{
			InitBuban101CommandBuffer(commid);
			MakeBuban101Command(commid, ASK_LINK);
			bRetVal = TRUE;
		}
		else
		{
			pPortParam->LinkOkCnt++;
			if(pPortParam->LinkOkCnt >= pPortParam->lTimeOutConst)
			{
				pPortParam->LinkOkCnt = 0;
				pPortParam->RstLinkOk = false;
			}
		}
		return bRetVal;
	}

	for(i = 0; i < BUBAN101_TIMER_CMD_NUM; i++)
	{
		if(pPortParam->CmdTime[i].CmdTimerConst )
			pPortParam->CmdTime[i].CmdTimerCnt++;
	}

	if(CheckPollCmdBufEmpty(commid) <= 0)
	{
		return bRetVal;
	}

	if (!pPortParam->Initdata )
	{
		// IEC-870-5-101ж֡ѯ
		//ҴĶIEC101Ҫٻڼ䲻
		//if(VER_IEC870_5_101 == pPortParam->RtuVersion)
		//	MakeBuban101Command( port, ASK_SECOND_DATA );
		return bRetVal;
	}
	
	iCurCmdIdx = pPortParam->CurCmdIdx;
	for ( i = 0; i < BUBAN101_TIMER_CMD_NUM; i++ )
	{		
		iCurCmdIdx = (iCurCmdIdx+1) % BUBAN101_TIMER_CMD_NUM;
		if ( (pPortParam->CmdTime[iCurCmdIdx].CmdTimerCnt 
				>= pPortParam->CmdTime[iCurCmdIdx].CmdTimerConst)				
				&& ( pPortParam->CmdTime[iCurCmdIdx].CmdTimerConst > 0 ))
			{
				pPortParam->CurCmdIdx = iCurCmdIdx;
				MakeBuban101Command(commid, framename[iCurCmdIdx]);
				pPortParam->CmdTime[iCurCmdIdx].CmdTimerCnt = 0;
				bRetVal = TRUE;
			}
	}

	if(FALSE == bRetVal)
	{
		MakeBuban101Command(commid, ASK_SECOND_DATA);
		bRetVal = TRUE;
	}

	return bRetVal;
}

void Buban101SendCmdFormPollCmdBuf(int commid)
{
	BYTE				fcb = 0x20;
	BYTE				buf[MAX_MSG_BUF_SIZE];
	i_32				len;
	BUBAN101PORTPARAM	*pPortParam;

	if((commid < 0) || (commid >= GetMaxPort()))
	{
		return;
	}

	if(!ShmGetPortFlag(commid, FLAG_OPEN))
	{
		return;
	}

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(pPortParam->m_psBaoHu->ForceWaitFlag 
		&& pPortParam->m_psBaoHu->ForceWaitCnt)
	{
		pPortParam->m_psBaoHu->ForceWaitCnt--;
		if(pPortParam->m_psBaoHu->ForceWaitCnt == 0)
		{
			// ǰ
			ClearCmdFormPollCmdBuf(commid);
			//ClearCmdAllFlag(commid);
		}
	}

	if(pPortParam->m_psBaoHu->SendCmdFlag 
		&& (pPortParam->m_psBaoHu->RevCmdFlag == 0))
    {
		pPortParam->m_psBaoHu->RetryTimeCnt++;
		if(pPortParam->m_psBaoHu->RetryTimeCnt < pPortParam->m_psBaoHu->RetryTime)
		{
			return;
		}

		pPortParam->m_psBaoHu->RetryTimeCnt = 0;

		pPortParam->m_psBaoHu->RetryCnt++;
		if(pPortParam->m_psBaoHu->RetryCnt > pPortParam->m_psBaoHu->Retry)
		{
			// ǰ
			ClearCmdFormPollCmdBuf(commid);
			//ClearCmdAllFlag(commid);
		}
		else
		{
			pPortParam->m_psBaoHu->SendCmdFlag = 0;
			pPortParam->m_psBaoHu->RevCmdFlag = 0;
			pPortParam->m_psBaoHu->ReSendCmdFlag = 1;
		}
	}

	if(pPortParam->m_psBaoHu->SendCmdFlag 
		&& pPortParam->m_psBaoHu->RevCmdFlag)
	{
		// ǰ
		ClearCmdFormPollCmdBuf(commid);
		//ClearCmdAllFlag(commid);
	}

	if(pPortParam->m_psBaoHu->WaitTime)
	{
		pPortParam->m_psBaoHu->WaitTimeCnt++;
		if(pPortParam->m_psBaoHu->WaitTimeCnt 
			< pPortParam->m_psBaoHu->WaitTime)
		{
			return;
		}
	}
	pPortParam->m_psBaoHu->WaitTimeCnt = 0;

	if(pPortParam->m_psBaoHu->ReSendCmdFlag)
	{
		len = ReGetCmdFormPollCmdBuf(commid, buf, sizeof(buf));
	}
	else
	{
		len = GetCmdFormPollCmdBuf(commid, buf, sizeof(buf));
	}

	if(len < 3)
	{
		return;
	}

#ifndef OS_LINUX
	if(isUdpSocketExist() == TRUE)
#endif
	{
		switch(buf[2])
		{
			case 0x10:
				if(PROTOCOL_SLAVE == pPortParam->m_psBaoHu->PortType)
					break;

				if((buf[3] & 0x40) == 0)
				{
					buf[5] = CalBuban101Lpc(&buf[3], 2);
					break;
				}

				if(pPortParam->m_psBaoHu->ReSendCmdFlag)
				{
					pPortParam->CtlByte = ~pPortParam->CtlByte;
				}
				buf[3] |= ( fcb & pPortParam->CtlByte );
				pPortParam->CtlByte = ~pPortParam->CtlByte;
				buf[5] = CalBuban101Lpc(&buf[3], 2);
				break;

			case 0x68:
				if(PROTOCOL_SLAVE == pPortParam->m_psBaoHu->PortType)
					break;

				if(pPortParam->m_psBaoHu->ReSendCmdFlag)
				{
					pPortParam->CtlByte = ~pPortParam->CtlByte;
				}
				buf[6] |= ( fcb & pPortParam->CtlByte );
				pPortParam->CtlByte = ~pPortParam->CtlByte;
				buf[buf[3]+6] = CalBuban101Lpc(&buf[6], buf[3]);
				break;

			default:
				break;
		}

		SendDataToPort(commid, (char *)&buf[2], len-2);
	
		pPortParam->m_psBaoHu->SendCmdFlag = 1;
		pPortParam->m_psBaoHu->ReSendCmdFlag = 0;
		pPortParam->m_psBaoHu->RevCmdFlag = 0;
		pPortParam->m_psBaoHu->RetryTimeCnt = 0;
	}

#ifdef OS_LINUX
	if(pPortParam->m_psBaoHu->LastGetCmdBuf == FAST_CMD_TYPE) 
#else
	if((pPortParam->m_psBaoHu->LastGetCmdBuf == FAST_CMD_TYPE) 
		|| !isUdpSocketExist()) 
#endif
	{
		pPortParam->m_psBaoHu->ForceWaitCnt = BYTE1(buf[0])+BYTE0(buf[1])+TIMER_CNT-1;
		pPortParam->m_psBaoHu->ForceWaitCnt /= TIMER_CNT;
		if(pPortParam->m_psBaoHu->ForceWaitCnt)
		{
			pPortParam->m_psBaoHu->ForceWaitFlag = 1;
		}
		else
		{
			ClearCmdFormPollCmdBuf(commid);		// ǰ
			//ClearCmdAllFlag(commid);			// ǰ
		}
	}
}
//===========================ָɺ=========================

//===========================Ϊݴ=======================
void Buban101ProcessData(u_32 commid, BUBAN101PORTPARAM *psPortParam, BOOL bProcess)
{
	RTUMSG				msg;
	BUBAN101PORTPARAM	*pPortParam;
	
	pPortParam = psPortParam;

	if(TRUE == bProcess)
	{
		msg.PortIdx = (BYTE)commid;
		msg.MsgLen = psPortParam->m_iRecvLen;
		memcpy(msg.MsgData, psPortParam->m_au8RecvBuf, msg.MsgLen);
		msg.MsgData[msg.MsgLen] = CHECK_WHOLE;
		msg.MsgData[msg.MsgLen+1] = 0;

		// վݴ
		if(PROTOCOL_SLAVE == pPortParam->m_psBaoHu->PortType)
		{
			ProvBuban101dataProcess(commid, &msg);
			return;
		}

		// վݴ
		switch(msg.MsgData[0])
		{
			case 0x68:
				Buban101longprocess(&msg);
				break;
			case 0x10:
				Buban101shortprocess(&msg);
				break;
			case 0xE5:
				Buban101NoChanged(&msg);
				break;
			default:
				break;
		}
	}
}

void Buban101NoChanged(RTUMSG * rtumsg)
{

}

//***************************************************************
//*			յΪ̶֡ʱĴ
//* RTUMSG* rtumsg:յϢ
//***************************************************************
void Buban101shortprocess(RTUMSG *rtumsg)
{
	int					framecnt = 0;
	int 				commid;
	BOOL				bMakeAllDataFlag;
	BUBAN101PORTPARAM	*pPortParam;
#ifdef _DEBUG_MSG_
	char szbuf[256];
#endif
	
	commid = rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	// wen 2003.08.11 жǷȫڸλոʱ
	bMakeAllDataFlag = pPortParam->LinkOk & pPortParam->RstLinkOk;
	if((rtumsg->MsgData[1] & 0xc0) == 0xc0)
	{
		switch(rtumsg->MsgData[1] & 0x0f)
		{
			case 0x0:		//λ·ȷ0000
				if(!pPortParam->RstLinkOk)
				{
					MakeBuban101Command(commid, ASK_LINK);
					break;
				}
				else
				{
					pPortParam->LinkOk = TRUE;
				}
				if(pPortParam->LinkOk && pPortParam->RstLinkOk)
				{
					if(!bMakeAllDataFlag)
					{
						MakeBuban101Command(commid, ASK_ALL_DATA);
					}
				}
				pPortParam->CtlByte = 0xff;
				MakeBuban101Command(commid, ACK);
				pPortParam->RstLinkOk = TRUE;
				break;		
			case 0x09:		//վվ
				if(bMakeAllDataFlag)
				{
					InitBuban101CommandBuffer(commid);
				}
				MakeBuban101Command(commid, ANS_LINK);				
				break;
			default:
				break;
		}
		return;
	}

	//վδ
	if(rtumsg->MsgData[1] & 0x10)
	{
		;
	}
	else
	{
		// wen 2004.03.16 ޸һݵѯֻҪһݾѯ
		//if( bMakeAllDataFlag )
		//{
		//	//һ
		//	if ( (rtumsg->MsgData[1] & 0x20) && pPortParam->Initdata )
		//		MakeBuban101Command ( port, ASK_FIRST_DATA);
		//}
		if(rtumsg->MsgData[1] & 0x20)
		{
			MakeBuban101Command(commid, ASK_FIRST_DATA);
		}
	}

	switch(rtumsg->MsgData[1] & 0x0f)
	{
		case 0x0:		//λ·ȷ0000
			if(pPortParam->RstLinkOk)
			{
				pPortParam->LinkOk = TRUE;
			}
			else
			{
				if(pPortParam->BalanceOrNot == 0)
				{
					pPortParam->LinkOk = TRUE;
					pPortParam->RstLinkOk = TRUE;
				}
			}

			if(pPortParam->LinkOk && pPortParam->RstLinkOk)
			{
				if(!bMakeAllDataFlag)
				{
					MakeBuban101Command(commid, ASK_ALL_DATA);
				}
			}
			pPortParam->RstLinkOk = TRUE;
			pPortParam->CtlByte = 0xff;
			break;
		case 0xb:		//·1011
			MakeBuban101Command(commid, RST_LINK);
			break;
		case 0x09:
			pPortParam->Initdata = TRUE;
			break;
		default:
			break;
	}
}

//***************************************************************
//*				յΪɱ֡ʱĴ
//* RTUMSG* rtumsg:յϢ
//***************************************************************
void Buban101longprocess(RTUMSG *rtumsg)
{	
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;
#ifdef _DEBUG_MSG_
	char szbuf[256];
#endif
	
	commid = rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	if ((rtumsg->MsgData[4] & 0xc0) != 0xc0)
	{
		//վδ
		if( rtumsg->MsgData[4] & 0x10)
		{
			;
		}
		else
		{
			// wen 2004.03.16 ޸һݵѯֻҪһݾѯ
			////һ
			//if( rtumsg->MsgData[4] & 0x20 && pPortParam->Initdata)
			//	MakeBuban101Command (rtumsg->PortNumber, ASK_FIRST_DATA);
			if(rtumsg->MsgData[4] & 0x20)
			{
				MakeBuban101Command(commid, ASK_FIRST_DATA);
			}
		}
	}
    
	switch (rtumsg->MsgData[6])
    {
		case 1:		// ңŴ
			Buban101DiDataProcess( rtumsg, 0 );
			break;

		case 2:		// ңSOE
			Buban101SoeDataProcess( rtumsg, 0 );
			break;

		case 3:		// ˫ңŴ
			Buban101DiDataProcess( rtumsg, 1 );
			break;

		case 4:		// ˫ңSOE
			Buban101SoeDataProcess( rtumsg, 1 );
			break;

		case 5:		// ѹֽͷλ
			break;
		case 6:		// ѹֽͷλôʱ
			break;
		case 7:		// վԶն״̬ 
			break;

		case 9:		// Ʒʱң
			Buban101AiWithPzDataProcess( rtumsg, 0 );
			break;

		case 10:	// Ʒʴʱң
			Buban101AiWithPzDataProcess( rtumsg, 1 );
			break;

		case 20:	// վңűλ֡
			Buban101AutoSendDiProcess( rtumsg );
			break;

		case 21:	// ȫңݴ 仯
			Buban101AllAiDataProcess( rtumsg );
			break;
			
		case 15:	// ʱ
			Buban101PiDataProcess( rtumsg );
			break;
		case 16:	// ʱ
			Buban101PiWithTimeDataProcess( rtumsg );
			break;

		case 17:	// ̵籣װõ¼˳¼֡
		case 18:	// ̵籣װó¼¼˳
		case 19:	// ̵籣װó·¼˳¼
			Buban101BaoHuDataProcess( rtumsg );
			break;

		// wen 2004.05.27 101Լ޸ĵ(???)
		case 30:    // CP56Time2aʱĵϢ   M_SP_TB_1
			Buban101SoeDataProcessWithCP56Time2a( rtumsg, 0 );
			break;
		case 31:    // CP56Time2aʱ˫Ϣ   M_DP_TB_1
			Buban101SoeDataProcessWithCP56Time2a( rtumsg, 1 );
			break;
		case 32:    // CP56Time2aʱĲλϢ M_ST_TB_1
			break;
		case 33:    // CP56Time2aʱ32ش   M_BO_TB_1
			break;
		case 34:    // CP56Time2aʱĲֵ, һֵ M_ME_TD_1  
			Buban101AiWithDataProcessWithM_ME_TD_1( rtumsg );
			break;
		case 35:    // CP56Time2aʱĲֵ, Ȼֵ M_ME_TE_1
			Buban101AiWithDataProcessWithM_ME_TE_1( rtumsg );
			break;
		case 36:    // CP56Time2aʱĲֵ, ̸ M_ME_TF_1
			Buban101AiWithDataProcessWithM_ME_TF_1( rtumsg );
			break;
		case 37:    // CP56Time2aʱۼ     M_IT_TB_1
			Buban101PiWithTimeDataProcessWithM_IT_TB_1( rtumsg );
			break;
		case 38:    // CP56Time2aʱļ̵籣װ¼ M_EP_TD_1
			break;
		case 39:    // CP56Time2aʱļ̵籣װó¼ M_EP_TE_1
			break;
		case 40:    // CP56Time2aʱļ̵籣װó·ϢM_EP_TF_1
			break;

		case 45:
		case 46:	// ңطУ
		case 47:	// ңУ
			Buban101YkYtAck( rtumsg );
			break;
		case 48:	// 趨ȷ
			Buban101SetAck( rtumsg );
			break;
		case 100:	// ٻȷ
			Buban101InitdataProecss( rtumsg );
			break;

		case 101:	// Ƚ֡
			Buban101PidataEnd( rtumsg );
			break;
		case 103:	// ʱͬȷ֡
			Buban101SynTime( rtumsg );
			break;

		default:
#ifdef _DEBUG_MSG_
			DebugPrint("յʶ.\n");
#endif
			break;
	}
} 

/* Buban101 ʼݴ */
void Buban101InitdataProecss(RTUMSG * rtumsg)
{
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;
	
	commid = rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	switch(rtumsg->MsgData[8])
	{
		case 7:
		case 9://ٻȷ			
			break;

		case 10://ٻ
			pPortParam->Initdata = TRUE;
			break;
	}
}

/* Ƚ֡ */
void Buban101PidataEnd(RTUMSG * rtumsg)
{
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;
	
	commid = rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(rtumsg->MsgData[8] & 0x40)
	{		
		pPortParam->Initdata = TRUE;
		return;
	}

	switch(rtumsg->MsgData[8])
	{
		case 7://ٻȷ
			break;

		case 10://ٻ
			pPortParam->Initdata = TRUE;
			break;
	}
}

//趨ȷ
void Buban101SetAck( RTUMSG *rtumsg)
{

}

//Buban101 ңңУ
void Buban101YkYtAck(RTUMSG * rtumsg)
{
	int					commid;
	YKYT_PARAM			YkYtParam;
	BUBAN101PORTPARAM	*pPortParam;
	
	commid = rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	YkYtParam.m_iYkYtPnt = (rtumsg->MsgData[11]<<8) + rtumsg->MsgData[10];
	YkYtParam.m_iYkYtPnt -= pPortParam->iYkBaseAddr;

	YkYtParam.m_iYkYtPnt %= 256;
	
	if(rtumsg->MsgData[12] & 0x80) //ѡУ
	{
		YkYtParam.m_iYkYtStep = STEP_YKYT_SELECT;

		//λΪ϶ȷλ
		if(rtumsg->MsgData[8] & 0x40)
		{
			YkYtParam.m_iYkYtOperate = 3;
		}
		else if(rtumsg->MsgData[8] == 0x07)
		{
			if(rtumsg->MsgData[6] != 45)
			{
				switch(rtumsg->MsgData[12] & 0x03)
				{
					case 1://ط
						if(pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate == 2)
						{
							YkYtParam.m_iYkYtOperate = pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate;
						}
						else
						{
							YkYtParam.m_iYkYtOperate = 3;
						}
						break;
					case 2://غ
						if(pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate == 1)
						{
							YkYtParam.m_iYkYtOperate = pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate;
						}
						else
						{
							YkYtParam.m_iYkYtOperate = 3;
						}
						break;
					default:
						YkYtParam.m_iYkYtOperate = 3;
						break;
				}
			}
			else
			{
				// غ
				if( rtumsg->MsgData[12] & 0x01 )
				{					
					if(pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate == 1)
					{
						YkYtParam.m_iYkYtOperate = pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate;
					}
					else
					{
						YkYtParam.m_iYkYtOperate = 3;
					}
				}
				// ط
				else
				{
					if(pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate == 2)
					{
						YkYtParam.m_iYkYtOperate = pPortParam->m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate;
					}
					else
					{
						YkYtParam.m_iYkYtOperate = 3;
					}
				}
			}
		}

		YkYtParam.m_iYkYtUpDown = YKYT_SEND_UP;
		SendYkYtCommand2(commid, &YkYtParam);
	}
	else //ִв
	{		
		//λΪ϶ȷλ
		if( ( rtumsg->MsgData[8] & 0x40 ) == 0 )
		{			
			switch( rtumsg->MsgData[8] )
			{
				case 0x07://ִȷ
					break;
				case 0x0a://ִ
					break;
				default:
					break;
			}
		}
	}
}

/* Buban101 ʱ */
void Buban101SynTime(RTUMSG * rtumsg)
{
	int					commid;
	DAY_TIME			stime;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(1 != pPortParam->m_psBaoHu->CheckTime)
	{
		return;
	}
	
	if(rtumsg->MsgData[8] != 0x07)
		return;

	stime.mSec = (rtumsg->MsgData[13]<<8) + rtumsg->MsgData[12];
	stime.Sec  = stime.mSec / 1000;
	stime.mSec %= 1000;
	stime.Min  = rtumsg->MsgData[14] & 0x3F;
	stime.Hour = rtumsg->MsgData[15] & 0x1F;
	stime.Day  = rtumsg->MsgData[16] & 0x1F;
	stime.Month= rtumsg->MsgData[17] & 0x0F;
	stime.Year = (rtumsg->MsgData[18] & 0x7F)+2000;
	SetLocalTimeEx(&stime);
}

/* վңűλ֡ */
void Buban101AutoSendDiProcess(RTUMSG *rtumsg)
{
	int			i, j, dipnt, len;
	DI_DEF		pntmsg;
	WORD		wStatus, wStatusBit;
	
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];

	//վϷ 仯ң
	//if( ( rtumsg->MsgData[8] & 0x0f ) == 0x03 ) //Ӽ̱ʹøñ(ʾ20ԭ20)Ӧٻ˽жȡjessie in 2003.04.15
	//{	
		// wen 2002.09.06 ңңݴ
		//len -= 6;
		//for ( i = 10; i < 10 + len; i += 7 )
		for ( i = 10; i < 4 + len; i += 7 )
		{
			dipnt = rtumsg->MsgData[i+1];
			dipnt = rtumsg->MsgData[i] + (dipnt<<8) - pPortParam->iDiBaseAddr;
			
			wStatus = rtumsg->MsgData[i+3];
			wStatus = (wStatus<<8) + rtumsg->MsgData[i+2];
			wStatusBit = rtumsg->MsgData[i+5];
			wStatusBit = (wStatusBit<<8) + rtumsg->MsgData[i+4];

			for( j = 0; j < 16; j++ )
			{
				//Ҵı仯״̬Ϊ0ȡж jessie in 2004.19
				//if( wStatusBit & (0x0001 << j) )
				//{
					if( wStatus & (0x0001 << j) )
						pntmsg.Status = 1;
					else
						pntmsg.Status = 0;
					SetPntMsg(commid, dipnt+j, (void *)&pntmsg, DI_PNT_TYPE, PNT_STATUS);
				//}
			}
		}
		
		// wen 2005.09.28 ޸ĶݵȷӦ
		// MakeBuban101Command(commid, ACK);
		if(pPortParam->BalanceOrNot)
		{
			if((rtumsg->MsgData[4] & 0xc0) == 0xc0)
			{
				MakeBuban101Command(commid, ACK);
			}
		}
	//}
}

// Buban101 Ʒңݴ
void Buban101AiWithPzDataProcess(RTUMSG * rtumsg, int flag)
{
	int		i, aipnt, len;
	AI_DEF	pntmsg;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];
	
	//仯ң
	if((rtumsg->MsgData[7] & 0x80)==0)
	{
		for ( i = 10; i < 4 + len; i += 5 )
		{
			aipnt = rtumsg->MsgData[i+1];
			aipnt = (aipnt<<8) + rtumsg->MsgData[i] - pPortParam->iAiBaseAddr;

			pntmsg.RawValue = rtumsg->MsgData[i+3];
			pntmsg.RawValue = (pntmsg.RawValue<<8) + rtumsg->MsgData[i+2];
			// Ʒ
			// rtumsg->MsgData[i+4];
			
			SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
			
			// ʱ
			if(flag)
			{
				i += 3;
			}
		}
	}
	else// ңȫ
	{
		aipnt = rtumsg->MsgData[11];
		
		aipnt = (aipnt<<8) + rtumsg->MsgData[10] - pPortParam->iAiBaseAddr;
		
		if( len < 0 )
			return;
		
		for ( i = 12; i < len + 4; i+= 3 )
		{
			pntmsg.RawValue = rtumsg->MsgData[i+1];
			pntmsg.RawValue = (pntmsg.RawValue<<8) + rtumsg->MsgData[i];
					
			SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
			aipnt++;
			// Ʒ
			// rtumsg->MsgData[i+2];

			// ʱ
			if ( flag )
				i += 3;	
		}
	}
}

void Buban101AllAiDataProcess(RTUMSG *rtumsg)
{
	int		i, aipnt, len;
	AI_DEF	pntmsg;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];

	aipnt = 0;
	//仯ң
	if((rtumsg->MsgData[7] & 0x80)==0)
	{		
		for ( i = 10; i < len + 4; i+= 4 )
		{
			aipnt = rtumsg->MsgData[i+1];

			aipnt = (aipnt<<8) + rtumsg->MsgData[i] - pPortParam->iAiBaseAddr;
			
			pntmsg.RawValue = rtumsg->MsgData[i+3];
			pntmsg.RawValue = (pntmsg.RawValue<<8) + rtumsg->MsgData[i+2];

			SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
		}
		return;
	}
	
	//ȫң
	aipnt = rtumsg->MsgData[11];	
	aipnt = (aipnt<<8) + rtumsg->MsgData[10] - pPortParam->iAiBaseAddr;
	
	if(len < 0)
	{
		return;
	}

	for ( i = 12; i < len + 4; i+= 2 )
	{
		pntmsg.RawValue = rtumsg->MsgData[i+1];
		pntmsg.RawValue = (pntmsg.RawValue<<8) + rtumsg->MsgData[i];
		SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
		aipnt++;
	}
}

void Buban101DiDataProcess(RTUMSG *rtumsg, int flag)
{
	int			i, dipnt, len;
	DI_DEF		pntmsg;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	len = (int)rtumsg->MsgData[1];

	//վϷ 仯ң
	if( ( rtumsg->MsgData[8] & 0x0f ) == 0x03 )
	{
		for ( i = 10; i < 4 + len; i += 3 )
		{
			dipnt = rtumsg->MsgData[i+1];
			dipnt = (dipnt<<8) + rtumsg->MsgData[i] - pPortParam->iDiBaseAddr;

			if ( flag == 0 )
				pntmsg.Status = rtumsg->MsgData[i+2] & 0x1;
			else
			{
				switch ( rtumsg->MsgData[i+2] & 0x3 )
				{
					 case 1:
						pntmsg.Status = 1;
						break;
					 case 2:
						pntmsg.Status = 0;
						break;
					 default:
						pntmsg.Status = 0xff;
						break;
				}
			}
			if ( pntmsg.Status != 0xff )
			{
				SetPntMsg(commid, dipnt, (void *)&pntmsg, DI_PNT_TYPE, PNT_STATUS);
			}
		}

		// wen 2005.09.28 ޸ĶݵȷӦ
		if(pPortParam->BalanceOrNot)
		{
			if((rtumsg->MsgData[4] & 0xc0) == 0xc0)
			{
				MakeBuban101Command(commid, ACK);
			}
		}
		return;
	}

	if(rtumsg->MsgData[7] & 0x80)
	{
		dipnt = rtumsg->MsgData[11];
		dipnt = (dipnt<<8) + rtumsg->MsgData[10] - pPortParam->iDiBaseAddr;

		for ( i = 12; i < 4 + len; i++,dipnt++ )
		{
			if ( flag == 0 )
				pntmsg.Status = rtumsg->MsgData[i] & 0x1;
			else
			{
				switch ( rtumsg->MsgData[i] & 0x3 )
				{
					 case 1:
						pntmsg.Status = 1;
						break;
					 case 2:
						pntmsg.Status = 0;
						break;
					 default:
						pntmsg.Status = 0xff;
						break;
				}
			}
			if(pntmsg.Status != 0xff)
			{
				SetPntMsg(commid, dipnt, (void *)&pntmsg, DI_PNT_TYPE, PNT_STATUS);
			}
		}
	}
	else
	{
		for ( i = 10; i < 4 + len; i += 3 )
		{
			dipnt = rtumsg->MsgData[i+1];
			dipnt = (dipnt<<8) + rtumsg->MsgData[i] - pPortParam->iDiBaseAddr;
			
			if ( flag == 0 )
				pntmsg.Status = rtumsg->MsgData[i+2] & 0x1;
			else
			{
				switch ( rtumsg->MsgData[i+2] & 0x3 )
				{
					 case 1:
						pntmsg.Status = 1;
						break;
					 case 2:
						pntmsg.Status = 0;
						break;
					 default:
						pntmsg.Status = 0xff;
						break;
				}
			}
			if(pntmsg.Status != 0xff)
			{
				SetPntMsg(commid, dipnt, (void *)&pntmsg, DI_PNT_TYPE, PNT_STATUS);
			}
		}
	}
}

void Buban101SoeDataProcess(RTUMSG *rtumsg, int flag)
{
	_int64				i64Millseconds;
	time_t				iTime;
	int					i, pnt, len;
    char 				st;
	int					sec;
	DI_DEF				pntmsg;
	DAY_TIME			sm;
	struct	tm			*testtm;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];
	for ( i = 10; i < len + 4; i += 6 )
	{
		pnt = rtumsg->MsgData[i+1];
		pnt = (pnt<<8) + rtumsg->MsgData[i] - pPortParam->iDiBaseAddr;
		
		if ( flag == 0 )
			st = rtumsg->MsgData[i+2] & 0x01;
		else
		{
			switch ( rtumsg->MsgData[i+2] & 0x3 )
			{
				 case 1:
					st = 1;
					break;
				 case 2:
					st = 0;
					break;
				 default:
					st = 0x0f;
					break;
			}
		}
		if ( st == 0x0f )
			continue;

		sec = rtumsg->MsgData[i+3] + ( rtumsg->MsgData[i+4] << 8 );
		pntmsg.SoeTime.mSec = sec % 1000;
		pntmsg.SoeTime.Sec = sec / 1000;
		pntmsg.SoeTime.Min = (rtumsg->MsgData[i+5] & 0x3f);	// 		
		GetLocalTimeEx(&sm);
		if(abs(pntmsg.SoeTime.Min-sm.Min) > 50)
		{
			i64Millseconds = SystemTimeToMillseconds(&sm, 0);
			if(i64Millseconds > 0)
			{
				// ȥһСʱ
				iTime = (long)(i64Millseconds/1000) - 3600;
				testtm = localtime(&iTime);
				sm.Year = testtm->tm_year + 1900;
				sm.Month = testtm->tm_mon + 1;
				sm.Day = testtm->tm_mday;
				sm.Hour = testtm->tm_hour;
				sm.Min = testtm->tm_min;
				sm.Sec = testtm->tm_sec;
			}
		}
		
		pntmsg.SoeTime.Hour = sm.Hour;
		pntmsg.SoeTime.Day = sm.Day;
		pntmsg.SoeTime.Month = sm.Month;
		pntmsg.SoeTime.Year = sm.Year;
		pntmsg.Status = st;

		SetPntMsg(commid, pnt, (void *)&pntmsg, DI_PNT_TYPE, PNT_SOE_TIME);
	}
}

void Buban101PiDataProcess( RTUMSG * rtumsg )
{
	int					i, point, len;
	PI_DEF				pntmsg;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	len = (int)rtumsg->MsgData[1];
	for(i = 10; i < 4 + len; i += 7)
    {
		point = rtumsg->MsgData[i+1];
		point = (point<<8) + rtumsg->MsgData[i] - pPortParam->iPiBaseAddr;

		pntmsg.RawValue = (rtumsg->MsgData[i+5]<<24) + (rtumsg->MsgData[i+4]<<16) 
					+ (rtumsg->MsgData[i+3]<<8) + rtumsg->MsgData[i+2];
		
		SetPntMsg(commid, point, (void *)&pntmsg, PI_PNT_TYPE, PNT_RAWVALUE);
    }
}

void Buban101PiWithTimeDataProcess( RTUMSG *rtumsg )
{
	int					i, point, len;
	PI_DEF				pntmsg;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	len = (int)rtumsg->MsgData[1];    
	for ( i = 10; i < 4 + len; i += 10 )
    {
		point = rtumsg->MsgData[i+1];

		point = (point<<8) + rtumsg->MsgData[i] - pPortParam->iPiBaseAddr;

		pntmsg.RawValue = (rtumsg->MsgData[i+5]<<24) + (rtumsg->MsgData[i+4]<<16)
			+ (rtumsg->MsgData[i+3]<<8) + rtumsg->MsgData[i+2];

		SetPntMsg(commid, point, (void *)&pntmsg, PI_PNT_TYPE, PNT_RAWVALUE);
    }
}

void Buban101BaoHuDataProcess( RTUMSG *rtumsg )
{
	// ùܲ
}

void Buban101DefaultBaoHuDataProcess( RTUMSG *rtumsg )
{
	// ùܲ
}

//  7 BYTE ʱ
//***************************************************************
//*				 Buban101 SOE ݴ(7 bytes ʱ)           	*
//***************************************************************
void Buban101SoeDataProcessWithCP56Time2a( RTUMSG *rtumsg, int flag )
{
	_int64				i64Millseconds;
	time_t				iTime;
	int					i, pnt, len;
    char 				st;
	int					sec;
	DI_DEF				pntmsg;
	DAY_TIME			sm;
	struct				tm *testtm;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];
	for ( i = 10; i < len + 4; i += 9 )
	{
		pnt = rtumsg->MsgData[i+1];
		pnt = (pnt<<8) + rtumsg->MsgData[i] - pPortParam->iDiBaseAddr;
		
		if(flag == 0)
		{
			st = rtumsg->MsgData[i+2] & 0x01;
		}
		else
		{
			switch ( rtumsg->MsgData[i+2] & 0x3 )
			{
				 case 1:
					st = 1;
					break;
				 case 2:
					st = 0;
					break;
				 default:
					st = 0x0f;
					break;
			}
		}
		if(st == 0x0f)
		{
			continue;
		}

		sec = rtumsg->MsgData[i+3] + (rtumsg->MsgData[i+4] << 8);
		pntmsg.SoeTime.mSec = sec % 1000;
		pntmsg.SoeTime.Sec = sec / 1000;
		pntmsg.SoeTime.Min = (char)(rtumsg->MsgData[i+5] & 0x3f);
		pntmsg.SoeTime.Hour = (char)(rtumsg->MsgData[i+6] & 0x1f);
		pntmsg.SoeTime.Day = (char)(rtumsg->MsgData[i+7] & 0x1f);

		GetLocalTimeEx(&sm);
		if((pntmsg.SoeTime.Day-sm.Day) < 0)
		{
			i64Millseconds = SystemTimeToMillseconds(&sm, 0);
			if(i64Millseconds > 0)
			{
				// ȥһСʱ
				iTime = (long)(i64Millseconds/1000) - 3600;
				testtm = localtime(&iTime);
				sm.Year = testtm->tm_year + 1900;
				sm.Month = testtm->tm_mon + 1;
				sm.Day = testtm->tm_mday;
				sm.Hour = testtm->tm_hour;
				sm.Min = testtm->tm_min;
				sm.Sec = testtm->tm_sec;
			}
		}

		pntmsg.SoeTime.Month = sm.Month;
		pntmsg.SoeTime.Year = sm.Year;
		pntmsg.Status = st;
		SetPntMsg(commid, pnt, (void *)&pntmsg, DI_PNT_TYPE, PNT_SOE_TIME);
	}
}

void Buban101AiWithDataProcessWithM_ME_TD_1(RTUMSG * rtumsg)
{
	int					i, aipnt, len;
	AI_DEF				pntmsg;
	char				szbuf[256];
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];	
	//仯ң
	for(i = 10; i < 4 + len; i += 12)
	{
		if( ( i + 12 ) > (4 + len))
		{
			sprintf(szbuf, ">>>>>WARN(%04d): Commid_%02d (iLen=%d) is not enough in Buban101AiWithDataProcessWithM_ME_TD_1", 
				getpid(), commid, len);
			DebugPrint(szbuf);
			break;
		}
		aipnt = rtumsg->MsgData[i+1];
		
		aipnt = (aipnt<<8) + rtumsg->MsgData[i] - pPortParam->iAiBaseAddr;

		pntmsg.RawValue = rtumsg->MsgData[i+3];
		pntmsg.RawValue = (pntmsg.RawValue<<8) + rtumsg->MsgData[i+2];
		
		SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
		
		// 7ֽʱ
	}
}

void Buban101AiWithDataProcessWithM_ME_TE_1(RTUMSG * rtumsg)
{
	Buban101AiWithDataProcessWithM_ME_TD_1(rtumsg);
}

void Buban101AiWithDataProcessWithM_ME_TF_1(RTUMSG * rtumsg)
{
	int					i, aipnt, len;
	AI_DEF				pntmsg;
	char				szbuf[256];
	float				fValue;
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	
	len = (int)rtumsg->MsgData[1];

	//仯ң
	for ( i = 10; i < 4 + len; i += 14 )
	{
		if( ( i + 14 ) > (4 + len))
		{
			sprintf(szbuf, ">>>>>WARN(%04d): Commid_%02d (iLen=%d) is not enough in Buban101AiWithDataProcessWithM_ME_TF_1", 
				getpid(), commid, len);
			DebugPrint(szbuf);
			break;
		}
		aipnt = rtumsg->MsgData[i+1];

		aipnt = (aipnt<<8) + rtumsg->MsgData[i] - pPortParam->iAiBaseAddr;

		fValue = *((float *)&rtumsg->MsgData[i+2]);
		SequenceRtuToHost((char *)&fValue, sizeof(float));
		
		// Ʒ
		// rtumsg->MsgData[i+6];
		
		// 2λС
		pntmsg.RawValue = (int)(fValue * 100);
		SetPntMsg(commid, aipnt, (void *)&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
			
		// 7ֽʱ
	}
}

//Buban101 ݴwith time
void Buban101PiWithTimeDataProcessWithM_IT_TB_1(RTUMSG *rtumsg)
{
	int					i, point, len;
	AI_DEF				pntmsg;
	char				szbuf[256];
	int					commid;
	BUBAN101PORTPARAM	*pPortParam;

	commid	= rtumsg->PortIdx;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	len = (int)rtumsg->MsgData[1];    
	for(i = 10; i < 4 + len; i += 14)
    {
		if( ( i + 14 ) > (4 + len))
		{
			sprintf(szbuf, ">>>>>WARN(%04d): Commid_%02d (iLen=%d) is not enough in Buban101PiWithTimeDataProcessWithM_IT_TB_1", 
				getpid(), commid, len);
			DebugPrint(szbuf);
			break;
		}

		point = rtumsg->MsgData[i+1];
		point = (point<<8) + rtumsg->MsgData[i] - pPortParam->iPiBaseAddr;

		pntmsg.RawValue = (rtumsg->MsgData[i+5]<<24) + (rtumsg->MsgData[i+4]<<16)
			+ (rtumsg->MsgData[i+3]<<8) + rtumsg->MsgData[i+2];

		SetPntMsg(commid, point, (void *)&pntmsg, PI_PNT_TYPE, PNT_RAWVALUE);

		// 1 BYTE (IV CA CY     ˳)
		// 7 BYTE ʱ
    }
}

//=========================ΪBuban101תݹ=======================//
void ProvBuban101dataProcess(int commid, RTUMSG *rtumsg)
{
	// У( ֽڵĵڶֽ)
	if(rtumsg->MsgData[rtumsg->MsgLen+1] > 0)
	{
		return;
	}

	switch(rtumsg->MsgData[0])
	{
		case 0x68:
			ProvBuban101longprocess(commid, rtumsg);
			break;

		case 0x10://shortframe process
			ProvBuban101shortprocess(commid, rtumsg);
			break;

		default:
			break;
	}
}

void ProvBuban101shortprocess(int commid, RTUMSG * rtumsg)
{
	int					framecnt = 0;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	//վ
	if((rtumsg->MsgData[1] & 0xc0) == 0x00)
	{
		switch(rtumsg->MsgData[1] & 0x0f)
		{
			case 0x0b://ش·״̬(·)
				ProvMakeBuban101Command(commid, RST_LINK);
				break;
			case 0x00://·ȷ
				if(pPortParam->RstLinkOk)
				{
					pPortParam->LinkOk = TRUE;
				}
				// wen 2005.09.13 ·ȷ֡ҪӦ
				//ProvMakeBuban101Command(commid, ACK);
				break;
			default:
				break;
		}
		return;
	}

	switch(rtumsg->MsgData[1] & 0x0f)
	{
		case 0x09://·״̬		
			ProvMakeBuban101Command(commid, ANS_LINK);
			break;
		case 0x00://λ·
			if(pPortParam->BalanceOrNot==0)
			{
				pPortParam->LinkOk = TRUE;
				pPortParam->RstLinkOk = TRUE;
				ProvMakeBuban101Command(commid, ACK);
			}
			else
			{
				pPortParam->LinkOk = FALSE;
				pPortParam->RstLinkOk = TRUE;				
				ProvMakeBuban101Command(commid, ACK);
				//ProvMakeBuban101Command(commid, RST_LINK);
				ProvMakeBuban101Command(commid, ASK_LINK);
			}
			break;
		case 0x0a://ٻһ
			if(pPortParam->LinkOk)
			{
				ProvMakeBuban101Command(commid, ASK_FIRST_DATA);
			}
			break;
		case 0x0b://ٻ
			if(pPortParam->LinkOk)
			{
				ProvMakeBuban101Command(commid, ASK_SECOND_DATA);
			}
			break;
		default:
			break;
	}
}

void ProvBuban101longprocess(int commid, RTUMSG * rtumsg)
{
	if((rtumsg->MsgData[4] & 0xc0) != 0x40)
	{
		ProvMakeBuban101Command(commid, ASK_DATA_NO);
	}

	switch(rtumsg->MsgData[6])
    {
		case 1:		// ңŴ
			break;

		case 2:		// ңSOE
			break;

		case 3:		// ˫ңŴ
			break;

		case 4:		// ңSOE
			break;

		case 5:		// ѹֽͷλ
			break;
		case 6:		// ѹֽͷλôʱ
			break;
		case 7:		// վԶն״̬ 
			break;

		case 9:		// Ʒʱң
			break;

		case 10:	// Ʒʴʱң
			break;
			
		case 21:	// ȫңݴ 仯
			break;
			
		case 15:	// ʱ
			break;
		case 16:	// ʱ
			break;

		case 17:
		case 18:
		case 19:	// 
			break;

		case 46:	// ңطУ
		case 47:	// ңУ
			ProvBuban101YkYtData(commid, rtumsg);
			break;

		case 100:	// ٻ
			ProvBuban101SendAllData(commid, rtumsg);
			break;

		case 101:	// ٻ
			ProvBuban101SendPIData(commid, rtumsg);
			break;
			
		case 103:	// ʱͬȷ֡
			ProvBuban101ProcessTime(commid, rtumsg);
			break;
	}
}

//Ӧٻٻ
//ٻȷ(ԭ[8]=0x07,0x09ȷ; =0x0a ٻ)
void ProvBuban101SendAllData(int commid, RTUMSG * rtumsg)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
	int		iGroup;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	//ٻ
	if(rtumsg->MsgData[12] != 20)
	{
		iGroup = rtumsg->MsgData[12] - 20;
		//Ч
		if( ( iGroup <= 0 ) || ( iGroup > 12 ) )
		{
			ProvMakeBuban101Command(commid, ASK_DATA_NO);
			return;
		}
		if(iGroup > 8)
		{
			iGroup -= 8;
			ProvBuban101SendAI(commid, rtumsg, iGroup);
		}
		else
			ProvBuban101SendDI(commid, rtumsg, iGroup);
		return;
	}
	
	//ٻ
	commandbuf[0] = 0x68;
	commandbuf[1] = 9;
	commandbuf[2] = 9;
	commandbuf[3] = 0x68;
	commandbuf[4] = 0x00;
	commandbuf[5] = pPortParam->LinkAddr;
	commandbuf[6] = 100;
	commandbuf[7] = 0;
	switch(rtumsg->MsgData[8])
	{
		case 0x06://
			commandbuf[8] = 7;
			break;
		case 0x08://ֹͣ
		default:
			commandbuf[8] = 9;
			break;
	}	
	commandbuf[9] = pPortParam->LinkAddr;
	commandbuf[10] = 0;
	commandbuf[11] = 0;
	commandbuf[12] = 0x14;	
	commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
	commandbuf[14] = 0x16;
	PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 15);

	if(rtumsg->MsgData[8] != 0x06) 
		return;
	
	ProvBuban101SendAI(commid, rtumsg, 0);
	ProvBuban101SendDI(commid, rtumsg, 0);
	
	//ٻ
	ProvMakeBuban101Command(commid, ASK_ALLDATA_END);
	pPortParam->m_psBaoHu->DiChange = FALSE;
}

void ProvBuban101SendPIData(int commid, RTUMSG * rtumsg)
{
	u_char				commandbuf[MAX_POLLCMD_BUF_LEN];
	int					iGroup = rtumsg->MsgData[12] & 0x3F;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	/*switch((rtumsg->MsgData[12]&0xc0)>>6)
	{
		case 0x00://Чָʽ
			break;
		case 0x01://᲻λ
			break;
		case 0x02://Ḵλ
			break;
		case 0x03://ܼλ
			break;
	}*/

	//ٻ	
	if( iGroup != 1 )
	{
		//Чչ
		if(( iGroup <= 0 ) || ( iGroup > 5 ))
		{
			ProvMakeBuban101Command(commid, ASK_DATA_NO);
			return;
		}
		
		ProvBuban101SendPI(commid, rtumsg, iGroup-1);
		return;
	}

	//ٻȷ
	commandbuf[0] = 0x68;
	commandbuf[1] = 9;
	commandbuf[2] = 9;
	commandbuf[3] = 0x68;
	commandbuf[4] = 0x00;
	commandbuf[5] = pPortParam->LinkAddr;
	commandbuf[6] = 101;
	commandbuf[7] = 0;
	commandbuf[8] = 7;
	commandbuf[9] = pPortParam->LinkAddr;
	commandbuf[10] = 0;
	commandbuf[11] = 0;
	commandbuf[12] = rtumsg->MsgData[12];
	commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
	commandbuf[14] = 0x16;
	PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 15);

	ProvBuban101SendPI(commid, rtumsg, 0);

	//ٻ
	commandbuf[0] = 0x68;
	commandbuf[1] = 9;
	commandbuf[2] = 9;
	commandbuf[3] = 0x68;
	commandbuf[4] = 0x80;
	commandbuf[5] = pPortParam->LinkAddr;
	commandbuf[6] = 101;
	commandbuf[7] = 0;
	commandbuf[8] = 10;
	commandbuf[9] = pPortParam->LinkAddr;
	commandbuf[10] = 0;
	commandbuf[11] = 0;
	commandbuf[12] = rtumsg->MsgData[12];
	commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
	commandbuf[14] = 0x16;
	PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 15);
}

void ProvBuban101ProcessTime(int commid, RTUMSG *rtumsg)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
	BUBAN101PORTPARAM	*pPortParam;
	DAY_TIME			sCurTime;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	//ԭ
	switch(rtumsg->MsgData[8])
	{
		case 0x06://(ʱ)
			commandbuf[0] = 0x68;
			commandbuf[1] = 15;
			commandbuf[2] = 15;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x53;
			commandbuf[5] = pPortParam->LinkAddr;
			commandbuf[6] = 103;
			commandbuf[7] = 1;
			commandbuf[8] = 7;
			commandbuf[9] = pPortParam->LinkAddr;
			commandbuf[10] = 0;
			commandbuf[11] = 0;
			memcpy(commandbuf+12, rtumsg->MsgData+12, 7);
			commandbuf[19] = CalBuban101Lpc(&commandbuf[4], commandbuf[1]);
			commandbuf[20] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 21);

			// wen 2006.03.29 Ӷʱ
			if(1 == pPortParam->m_psBaoHu->CheckTime)
			{
				sCurTime.mSec = rtumsg->MsgData[12] + (rtumsg->MsgData[13] << 8);
				sCurTime.Sec  = sCurTime.mSec/1000;
				sCurTime.mSec = sCurTime.mSec % 1000;
				sCurTime.Min  = rtumsg->MsgData[14] & 0x3F;
				sCurTime.Hour = rtumsg->MsgData[15] & 0x1F;
				sCurTime.Day  = rtumsg->MsgData[16] & 0x1F;
				sCurTime.Month= rtumsg->MsgData[17] & 0x0F;
				sCurTime.Year = (rtumsg->MsgData[18] & 0x7F)+2000;

				SetLocalTimeEx(&sCurTime);
			}
			break;
		case 0x07://ȷ
			break;
	}
}

void ProvBuban101SendPI(int commid, RTUMSG *rtumsg, int iGroupNo)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];		
	WORD	wStartAddr;
	int		iLenth, iSendCount=1;
	int		i, j, iAllDataCount, iSendNum;
	int		iNo;	
	PI_DEF	pntmsg;
	PROV_PI_PNT *piprovptr;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(iGroupNo == 0)//ٻ
	{
		wStartAddr = MAX_GROUP_PINUM*iGroupNo + pPortParam->iPiBaseAddr;

		iAllDataCount = pPortParam->m_psBaoHu->PiNum;
		iSendCount = (iAllDataCount+MAX_PINUM-1)/MAX_PINUM;		
	}
	else//ٻ
	{
		wStartAddr = MAX_GROUP_PINUM*(iGroupNo-1);
		iAllDataCount = pPortParam->m_psBaoHu->PiNum - wStartAddr;
		
		wStartAddr += pPortParam->iPiBaseAddr;

		if( iAllDataCount > MAX_GROUP_PINUM)
		{
			iSendCount = 2;
			if((iAllDataCount - MAX_GROUP_PINUM)>0)
				iAllDataCount = MAX_GROUP_PINUM;
		}
	}

	piprovptr = (PROV_PI_PNT *)pPortParam->m_psBaoHu->PiPtr;
	for(i = 0; i < iSendCount; i++)
	{
		commandbuf[0] = 0x68;
		commandbuf[3] = 0x68;
		commandbuf[4] = 0x08;
		commandbuf[5] = pPortParam->LinkAddr;
		commandbuf[6] = 15;		
		commandbuf[8] = 37+iGroupNo;
		commandbuf[9] = pPortParam->LinkAddr;		
		//ңֵ
		if(iAllDataCount>MAX_PINUM)
		{
			iAllDataCount -= MAX_PINUM;
			iSendNum = MAX_PINUM;
		}
		else
		{
			iSendNum = iAllDataCount;
		}

		for(j = 0, iLenth = 10; j < iSendNum; j++, wStartAddr++)
		{
			commandbuf[iLenth++] = (char)(wStartAddr &0x00ff);
			commandbuf[iLenth++] = (char)((wStartAddr &0xff00)>>8);			

			iNo = wStartAddr - pPortParam->iPiBaseAddr;

			pntmsg.RawValue = 0;
			GetPntMsg(piprovptr[iNo].PortNo, piprovptr[iNo].PntNo,
				(void *)&pntmsg, PI_PNT_TYPE, PNT_RAWVALUE);
			piprovptr[iNo].ChangeFlag = FALSE;
			
			commandbuf[iLenth++] = (char)(pntmsg.RawValue & 0x000000ff);
			commandbuf[iLenth++] = (char)((pntmsg.RawValue & 0x0000ff00)>>8);
			commandbuf[iLenth++] = (char)((pntmsg.RawValue & 0x00ff0000)>>16);
			commandbuf[iLenth++] = (char)((pntmsg.RawValue & 0xff000000)>>24);
			commandbuf[iLenth++] = (char)(j+1);			
		}

		commandbuf[7] = (BYTE)j;
		commandbuf[1] = (char)(iLenth-4);
		commandbuf[2] = commandbuf[1];
		commandbuf[iLenth++] = CalBuban101Lpc(&commandbuf[4], commandbuf[1]);
		commandbuf[iLenth++] = 0x16;
		if(iGroupNo != 0)
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
		else 
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
	}
}

void ProvBuban101SendAI(int commid, RTUMSG *rtumsg, int iGroupNo)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];		
	WORD	wStartAddr;
	int		iLenth, iSendCount=1;
	int		i, j, iAllDataCount, iSendNum;
	int		iNo;
	AI_DEF      pntmsg;
	PROV_AI_PNT	*aiprovptr;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if( iGroupNo == 0 )//ٻ
	{
		wStartAddr = MAX_GROUP_AINUM*iGroupNo + pPortParam->iAiBaseAddr;

		iAllDataCount = pPortParam->m_psBaoHu->AiNum;
		iSendCount = (iAllDataCount+MAX_AINUM-1)/MAX_AINUM;		
	}
	else//ٻ
	{
		wStartAddr = MAX_GROUP_AINUM*(iGroupNo-1);
		iAllDataCount = pPortParam->m_psBaoHu->AiNum - wStartAddr;		
		wStartAddr += pPortParam->iAiBaseAddr;
		
		if(iAllDataCount > MAX_AINUM)
		{
			iSendCount = 2;
			if((iAllDataCount - MAX_GROUP_AINUM) > 0)
			{
				iAllDataCount = MAX_GROUP_AINUM;
			}
		}
	}

	aiprovptr = (PROV_AI_PNT *)pPortParam->m_psBaoHu->AiPtr;
	for( i = 0; i < iSendCount; i++ )
	{
		commandbuf[0] = 0x68;
		commandbuf[3] = 0x68;
		commandbuf[4] = 0x08;
		commandbuf[5] = pPortParam->LinkAddr;
		commandbuf[6] = 21;		
		commandbuf[8] = rtumsg->MsgData[12];
		commandbuf[9] = pPortParam->LinkAddr;

		commandbuf[10] = (char)(wStartAddr);
		commandbuf[11] = (char)((wStartAddr&0xff00)>>8);
		//ңֵ
		if(iAllDataCount > MAX_AINUM)
		{
			iAllDataCount -= MAX_AINUM;
			iSendNum = MAX_AINUM;			
		}
		else
		{
			iSendNum = iAllDataCount;
		}

		iNo = wStartAddr - pPortParam->iAiBaseAddr;
		for(j = 0, iLenth = 12; j < iSendNum; j++)
		{
			GetPntMsg(aiprovptr[iNo+j].PortNo, aiprovptr[iNo+j].PntNo,
				&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
			aiprovptr[iNo+j].ChangeFlag = FALSE;			
			commandbuf[iLenth++] = (char)(pntmsg.RawValue);
			commandbuf[iLenth++] = (char)((pntmsg.RawValue&0xff00)>>8);
		}

		commandbuf[7] = (BYTE)j;
		commandbuf[7] |= 0x80;
		commandbuf[1] = commandbuf[2] = (char)(iLenth-4);
		commandbuf[iLenth++] = CalBuban101Lpc( &commandbuf[4], commandbuf[1]);
		commandbuf[iLenth++] = 0x16;
		if(iGroupNo != 0)
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
		else 
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
		wStartAddr += MAX_AINUM;
	}
}

void ProvBuban101SendDI(int commid, RTUMSG *rtumsg, int iGroupNo)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
		
	WORD	wStartAddr;
	int		iLenth, iSendCount=1;
	int		i, j, iAllDataCount, iSendNum;
	int		iNo;
	DI_DEF      pntmsg;
	PROV_DI_PNT	*diprovptr;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	if(iGroupNo == 0)//ٻ
	{
		wStartAddr = MAX_GROUP_DINUM*iGroupNo + pPortParam->iDiBaseAddr;

		iAllDataCount = pPortParam->m_psBaoHu->DiNum;
		iSendCount = (iAllDataCount+MAX_DINUM-1)/MAX_DINUM;		
	}
	else//ٻ
	{
		wStartAddr = MAX_GROUP_DINUM*(iGroupNo-1);
		iAllDataCount = pPortParam->m_psBaoHu->DiNum - wStartAddr;
		
		wStartAddr += pPortParam->iDiBaseAddr;

		if( iAllDataCount > MAX_GROUP_DINUM)
		{
			iAllDataCount = MAX_GROUP_DINUM;
		}
	}

	diprovptr = (PROV_DI_PNT *)pPortParam->m_psBaoHu->DiPtr;
	for(i=0; i<iSendCount; i++)
	{
		commandbuf[0] = 0x68;
		commandbuf[3] = 0x68;
		commandbuf[4] = 0x08;
		commandbuf[5] = pPortParam->LinkAddr;
		commandbuf[6] = 1;//=3,Ϊ˫
		commandbuf[8] = rtumsg->MsgData[12];
		commandbuf[9] = pPortParam->LinkAddr;		
		commandbuf[10] = (char)(wStartAddr);
		commandbuf[11] = (char)((wStartAddr&0xff00)>>8);

		if(iAllDataCount > MAX_DINUM)
		{
			iAllDataCount -= MAX_DINUM;
			iSendNum = MAX_DINUM;			
		}
		else
		{
			iSendNum = iAllDataCount;
		}

		iNo = wStartAddr - pPortParam->iDiBaseAddr;

		for( j = 0, iLenth = 12; j < iSendNum; j++ )
		{
			GetPntMsg(diprovptr[iNo+j].PortNo, diprovptr[iNo+j].PntNo,
				&pntmsg, DI_PNT_TYPE, PNT_STATUS);
			diprovptr[iNo+j].ChangeFlag = FALSE;
			commandbuf[iLenth++] = pntmsg.Status;
		}

		commandbuf[7] = (char)j;
		commandbuf[7] |= 0x80;
		commandbuf[1] = (char)(iLenth-4);
		commandbuf[2] = commandbuf[1];
		commandbuf[iLenth++] = CalBuban101Lpc( &commandbuf[4], commandbuf[1]);
		commandbuf[iLenth++] = 0x16;
		if(iGroupNo != 0)
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
		else 
		{
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
		}
		wStartAddr += MAX_DINUM;
	}
}

void ProvBuban101YkYtData(int commid, RTUMSG *rtumsg)
{
	PROV_DI_PNT		*diprovptr;
	DI_DEF			*diptr;	
	int				ykytcommid, provpnt;
	int				ykytpnt, ykytop, step;
	YKYT_PARAM		YkYtParam;
	BUBAN101PORTPARAM *pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;
	if(rtumsg->MsgData[8] == 8)
	{
		step = STEP_YKYT_CANCEL;
	}
	else
	{
		if(rtumsg->MsgData[12] & 0x80) //ѡУ
		{
			step = STEP_YKYT_SELECT;
		}
		else
		{
			step = STEP_YKYT_EXEC;			
		}
	}
	
	ykytpnt = 0;
	ykytop = 3;
			
	if(ShmGetDispYkYtFlag())
	{
		printf("TIP_(%04d): commid =%d recv ykyt select.\n", getpid(), commid);
	}

	ykytpnt = (rtumsg->MsgData[11]<<8) + rtumsg->MsgData[10];
	ykytpnt -= pPortParam->iYkBaseAddr;
	ykytpnt += 1;

	//ykytop = ((rtumsg->MsgData[12] & 0x03) == 1) ? 2 : 1;
	if(rtumsg->MsgData[6] == 45)
	{
		// ykytop == 1 غ, == 2 ط
		ykytop = ((rtumsg->MsgData[12] & 0x03) == 1) ? 1 : 2;
	}
	else if(rtumsg->MsgData[6] == 46)
	{
		ykytop = ((rtumsg->MsgData[12] & 0x03) == 2) ? 1 : 2;
	}
	else // == 47
	{
		//step = STEP_YKYT_CANCEL;
		MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
		return;
	}
		
	provpnt = FindProvPntFromYkYtPnt(commid, ykytpnt, pPortParam->m_psBaoHu);
	if(provpnt < 0)	// صŴ
	{
		MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
	}
	else
	{
		diprovptr = (PROV_DI_PNT *)pPortParam->m_psBaoHu->DiPtr;
		ykytcommid = diprovptr[provpnt].PortNo;
		if(!SioParam[ykytcommid].m_psBaoHu)
		{
			MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
			return;
		}

		if(!SioParam[ykytcommid].m_psBaoHu->DiPtr)
		{
			MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
			return;
		}

		diptr = (DI_DEF *)SioParam[ykytcommid].m_psBaoHu->DiPtr;

		// Ӧûпص߿ص㲻
		if(!diptr[diprovptr[provpnt].PntNo].CtrlEnable)
		{
			MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
			return;
		}

		if(STEP_YKYT_SELECT == step)
		{
			if(STEP_YKYT_SELECT == SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iYkYtStep)
			{
				if(!ProvPortYkYtIsTimeOut(ykytcommid, &SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg))
				{
					MakeProvBuban101YkYtAckMsg(commid, ykytpnt, 3, step);
					return;
				}
			}
		}

		SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iProvPntIdx = provpnt;
		SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iProvPortIdx = commid;
		SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iProvYkYtPointIdx = ykytpnt;
		SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iYkYtPointIdx = diptr[diprovptr[provpnt].PntNo].ControlNo;
		SioParam[ykytcommid].m_psBaoHu->ProvYkYtMsg.m_iYkYtOperate = ykytop;

		// buf[0] --- ˿ں(=commid)
		// buf[1]
		// buf[2]
		// buf[3]
		// buf[4] --- ص
		// buf[5]
		// buf[6]
		// buf[7]
		// buf[8] --- (ң:1=ѡ,2=ִ,3=ȡ,7=ֱ; 
		//                     ң:4=ѡ,5=ִ,6=ȡ,8=ͣ)
		// buf[9] --- ״̬(1=ֵϣ2=ϵ)
		//                    (λΪ1ʱΪУ, 1=ɹ, 0=ʧ)						
		//buf[0] = ykytcommid & 0xFF;
		//buf[1] = (ykytcommid & 0xFF00) >> 8;
		//buf[2] = (ykytcommid & 0xFF0000) >> 16;
		//buf[3] = (ykytcommid & 0xFF000000) >> 24;
		//buf[4] = diptr[diprovptr[provpnt].PntNo].ControlNo & 0xFF;
		//buf[5] = (diptr[diprovptr[provpnt].PntNo].ControlNo & 0xFF00) >> 8;
		//buf[6] = (diptr[diprovptr[provpnt].PntNo].ControlNo & 0xFF0000) >> 16;
		//buf[7] = (diptr[diprovptr[provpnt].PntNo].ControlNo & 0xFF000000) >> 24;						
		//buf[8] = STEP_YKYT_SELECT;
		//buf[9] = ykytop;						
		//SendYkYtCommand(ykytcommid, (char *)buf, 10);	// ңң

		YkYtParam.m_iYkYtOperate = ykytop;
		YkYtParam.m_iYkYtPnt = diptr[diprovptr[provpnt].PntNo].ControlNo;
		YkYtParam.m_iYkYtStep = step;
		YkYtParam.m_iYkYtUpDown = YKYT_SEND_DOWN;
		SendYkYtCommand2(ykytcommid, &YkYtParam);

		if(STEP_YKYT_EXEC == step)
		{
			MakeProvBuban101YkYtAckMsg(commid, ykytpnt, ykytop, step);
			MakeProvBuban101YkYtAckMsg(commid, ykytpnt, ykytop, STEP_YKYT_NOEXEC);
		}
	}
}

void MakeProvBuban101YkYtAckMsg(int commid, int pnt, int op, int step)
{
	int					iCount;
    u_char				commandbuf[MAX_POLLCMD_BUF_LEN];
	BUBAN101PORTPARAM	*pPortParam;
		
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	memset(commandbuf, 0, sizeof(commandbuf));
	iCount = 4;
	commandbuf[0] = 0x68;
	commandbuf[1] = 0x09;
	commandbuf[2] = 0x09;
	commandbuf[3] = 0x68;
	commandbuf[4] = 0x80;
	commandbuf[5] = pPortParam->LinkAddr;
	commandbuf[6] = 46;/*47*/
	commandbuf[7] = 1;
	// DCS/RCS
	switch(op)
	{
		case 1:	// ѡ
			commandbuf[12] = 2;
           	break;
       	case 2:	// ѡ
			commandbuf[12] = 1;
			break;
       	case 3:	// ѡʧ
		default:
			commandbuf[8] = 0x40;
			commandbuf[12] = 0;
			break;
	}
	// ԭ
	if(STEP_YKYT_SELECT == step)
	{
		commandbuf[8] |= 7;
		// DCS/RCS
		commandbuf[12] |= 0x80;
	}
	else if(STEP_YKYT_EXEC == step)
	{
		commandbuf[8] |= 7;
	}
	else if(STEP_YKYT_CANCEL == step)
	{
		commandbuf[8] |= 9;
		// DCS/RCS
		commandbuf[12] |= 0x80;
	}
	else// ֡
	{
		commandbuf[8] = 10;
	}
	commandbuf[9] = pPortParam->LinkAddr;
	commandbuf[10] = LOBYTE((WORD)(pnt+pPortParam->iYkBaseAddr));
	commandbuf[11] = HIBYTE((WORD)(pnt+pPortParam->iYkBaseAddr));

	commandbuf[13] = CalBuban101Lpc(&commandbuf[4], commandbuf[1]);
	commandbuf[14] = 0x16;
	PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 15);

	if(ShmGetDispYkYtFlag())
	{
		printf("TIP_(%04d): commid =%d ykytpnt=%d, op=%d checked.\n", getpid(), commid, pnt, op);
	}
}

void ProvBuban101SendClass1(int commid)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];
	WORD	wStartAddr;
	int		iLenth, iSendCount=1;
	int		j, iDataNum;
	DI_DEF      pntmsg;
	PROV_DI_PNT	*diprovptr;
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	// wen 2005.01.15 ޸Ϣʼַ
	wStartAddr = pPortParam->iDiBaseAddr;

	commandbuf[0] = 0x68;
	commandbuf[3] = 0x68;
	//commandbuf[4] = 0x08;
	commandbuf[5] = pPortParam->LinkAddr;
	commandbuf[6] = 1;//=3,Ϊ˫	
	//commandbuf[8] = 3;
	commandbuf[8] = 5;// ӦΪݣͻ
	commandbuf[9] = pPortParam->LinkAddr;
	
	diprovptr = (PROV_DI_PNT *)pPortParam->m_psBaoHu->DiPtr;
	for(j = 0, iDataNum = 0, iLenth = 10; j < pPortParam->m_psBaoHu->DiNum; j++)
	{
		if(diprovptr[j].ChangeFlag)
		{
			iDataNum++;
			commandbuf[iLenth++] = (char)(wStartAddr+j);
			commandbuf[iLenth++] = (char)((wStartAddr+j)>>8);

			GetPntMsg(diprovptr[j].PortNo, diprovptr[j].PntNo,
				&pntmsg, DI_PNT_TYPE, PNT_STATUS);
			diprovptr[j].ChangeFlag = FALSE;
			commandbuf[iLenth++] = pntmsg.Status;
			if(iLenth > 256)
			{
				break;
			}
		}
	}

	if(j >= pPortParam->m_psBaoHu->DiNum)
	{
		pPortParam->m_psBaoHu->DiChange = FALSE;
	}

	if(pPortParam->m_psBaoHu->DiChange)
	{
		commandbuf[4] = 0x28;
	}
	else
	{
		commandbuf[4] = 0x08;
	}

	commandbuf[7] = (char)iDataNum;
	commandbuf[1] = (char)(iLenth-4);
	commandbuf[2] = commandbuf[1];
	commandbuf[iLenth++] = CalBuban101Lpc( &commandbuf[4], commandbuf[1]);
	commandbuf[iLenth++] = 0x16;
	PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
}

void ProvBuban101SendClass2(int commid)
{
	u_char	commandbuf[MAX_POLLCMD_BUF_LEN];

	BOOL	bHaveData = FALSE;
	WORD	wStartAddr, wmSec;
	int		iLenth;
	int		j, iDataNum;
	AI_DEF      pntmsg;
	SOE_DEF  	soemsg;
	PROV_AI_PNT	*aiprovptr;
	BUBAN101PORTPARAM	*pPortParam;

	iDataNum = 0;
	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

	commandbuf[0] = 0x68;
	commandbuf[3] = 0x68;
	if(pPortParam->m_psBaoHu->DiChange)
	{
		commandbuf[4] = 0x28;
	}
	else
	{
		commandbuf[4] = 0x08;
	}
	commandbuf[5] = pPortParam->LinkAddr;	
	//commandbuf[8] = 3;
	commandbuf[8] = 5;
	commandbuf[9] = pPortParam->LinkAddr;
	
	//SOE 
	if(ProvHaveSoeData(commid) > 0)
	{
		// 
		commandbuf[6] = 2;
		bHaveData = TRUE;
		iLenth = 10;
		// wen 2005.01.15 ޸Ϣʼַ
		wStartAddr = pPortParam->iDiBaseAddr;

		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		// wen 2006.07.12 ޸soeΪʱݶʧ.
		/*
		while(ProvAndDelGetSoeData(commid, &soemsg) > 0)
		{
			iDataNum++;
			commandbuf[iLenth++] = (char)(wStartAddr+soemsg.iPntNo);
			commandbuf[iLenth++] = (char)((wStartAddr+soemsg.iPntNo)>>8);
			commandbuf[iLenth++] = soemsg.bStatus;
			wmSec = soemsg.SoeTime.mSec + soemsg.SoeTime.Sec*1000;
			commandbuf[iLenth++] = LOBYTE(wmSec);
			commandbuf[iLenth++] = HIBYTE(wmSec);
			commandbuf[iLenth++] = soemsg.SoeTime.Min;
			if(iLenth >= 255)
			{
				break;
			}
		}
		*/
		//===========================================================
		while(ProvHaveSoeData(commid) > 0)
		{
			ProvAndDelGetSoeData(commid, &soemsg);
			iDataNum++;
			commandbuf[iLenth++] = (char)(wStartAddr+soemsg.iPntNo);
			commandbuf[iLenth++] = (char)((wStartAddr+soemsg.iPntNo)>>8);
			commandbuf[iLenth++] = soemsg.bStatus;
			wmSec = soemsg.SoeTime.mSec + soemsg.SoeTime.Sec*1000;
			commandbuf[iLenth++] = LOBYTE(wmSec);
			commandbuf[iLenth++] = HIBYTE(wmSec);
			commandbuf[iLenth++] = soemsg.SoeTime.Min;
			if(iLenth >= 255)
			{
				break;
			}
		};
		//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	}
	else
	{
		// wen 2005.01.15 ޸Ϣʼַ
		wStartAddr = pPortParam->iAiBaseAddr;
		commandbuf[6] = 21;
		//ңֵ
		aiprovptr = (PROV_AI_PNT *)pPortParam->m_psBaoHu->AiPtr;
		for(j = 0, iDataNum = 0, iLenth = 10; j < pPortParam->m_psBaoHu->AiNum; j++)
		{
			if(aiprovptr[j].ChangeFlag)
			{
				iDataNum++;
				bHaveData = TRUE;

				commandbuf[iLenth++] = (char)(wStartAddr+j);
				commandbuf[iLenth++] = (char)((wStartAddr+j)>>8);

				GetPntMsg(aiprovptr[j].PortNo, aiprovptr[j].PntNo,
					&pntmsg, AI_PNT_TYPE, PNT_RAWVALUE);
				aiprovptr[j].ChangeFlag = FALSE;
				commandbuf[iLenth++] = (char)(pntmsg.RawValue);
				commandbuf[iLenth++] = (char)((pntmsg.RawValue&0xff00)>>8);

				if(iLenth >= 255)
				{
					break;
				}
			}
		}
	}

	if(bHaveData)
	{
		commandbuf[7] = (char)iDataNum;
		commandbuf[1] = (char)(iLenth-4);
		commandbuf[2] = commandbuf[1];
		commandbuf[iLenth++] = CalBuban101Lpc( &commandbuf[4], commandbuf[1]);
		commandbuf[iLenth++] = 0x16;
		PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, iLenth);
	}
	else
	{
		if(pPortParam->m_psBaoHu->DiChange)
		{
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x29;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
		}
		else
		{
			commandbuf[0] = 0xE5;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 1);
		}
	}
}

void ProvMakeBuban101Command(int commid, u_char cmdidx)
{
	u_char				commandbuf[MAX_POLLCMD_BUF_LEN];
	BUBAN101PORTPARAM	*pPortParam;

	pPortParam = (BUBAN101PORTPARAM *)SioParam[commid].ExtInfo;

    switch(cmdidx)
    {
		case ASK_LINK:				// ·
			commandbuf[0] = 0x10;
			commandbuf[1] = 0xc9;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
			break;

		case RST_LINK:				// λ·
			commandbuf[0] = 0x10;
			commandbuf[1] = 0xc0;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
			break;
		
		case ASK_SECOND_DATA:		// ٻ2
			ProvBuban101SendClass2(commid);
			break;

		case ASK_FIRST_DATA:		// ٻ1
			ProvBuban101SendClass1(commid);
			break;

		case ACK:					// ȷϻش
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x00;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
			break;

		case ANS_LINK:				// ش·״̬
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x0b;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
			break;

		case ASK_DATA_NO:			// 
			commandbuf[0] = 0x10;
			commandbuf[1] = 0x09;
			commandbuf[2] = pPortParam->LinkAddr;
			commandbuf[3] = CalBuban101Lpc(&commandbuf[1], 2);
			commandbuf[4] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 5);
			break;

		case ASK_ALLDATA_END:		// ٻ֡
			commandbuf[0] = 0x68;
			commandbuf[1] = 9;
			commandbuf[2] = 9;
			commandbuf[3] = 0x68;
			commandbuf[4] = 0x08;
			commandbuf[5] = pPortParam->LinkAddr;
			commandbuf[6] = 100;
			commandbuf[7] = 1;
			commandbuf[8] = 10;
			commandbuf[9] = pPortParam->LinkAddr;
			commandbuf[10] = 0;
			commandbuf[11] = 0;
			commandbuf[12] = 0x14;
			commandbuf[13] = CalBuban101Lpc(&commandbuf[4], 9);
			commandbuf[14] = 0x16;
			PutPollCmdToBuf(commid, FAST_POLL_CMD, 0, (char *)commandbuf, 15);
			break;

		case RTU_TIME:				// ʱͬ
			break;

		case ASK_DI_DATA:			// ٻ2YX
			break;

		case ASK_AI_DATA:			// ٻ2YC
			break;

		case ASK_PI_DATA:			// ٻ2YM
			break;

		case ASK_PI:				//ٻ
			break;

		case ASK_ALL_DATA:			// ٻʼ			
			break;
    }
}
//===========================תݴ===============================//

//===========================ݴ===============================//