/************************************************************************
 *
 *	Copyright (C) 2003-2004
 *	Shenzhen SCADA Control Technology Co., Ltd.
 *	All rights reserved.
 *	
 *	ڵڴй©Ķڴ亯
 *
 *	:	2005/04/12
 *
 ***********************************************************************/

#ifndef __OS_HEAP_H_ASDFJLCXJVZXHCROEYUIODFGFMHFOIUHSDIHFZXKJCHGVLSDHFAJD
#define __OS_HEAP_H_ASDFJLCXJVZXHCROEYUIODFGFMHFOIUHSDIHFZXKJCHGVLSDHFAJD

#include "basetype.h"

/*!
 *  \brief ڴ
 *
 *  \param size ϣڴĳߴ
 *  \param file ָڴԴļƣnullַβ
 *              NULL ʾԴļ(anony)
 *  \param line ڴԴк
 *
 *  \retutrn 
 *      ڴɹ£ָڴָ롣ڴ
 *      ʧܣNULL
 *
 *  \note
 *      ڴ治ʹʱheap_freeǷڴ档
 *
 *      μ ANSI C  malloc
 */
DSLIB_API void * heap_malloc (size_t size, const char * file, int line);


/*!
 *  \brief ڴ, ڴ鱻ʼ0.
 *
 *  \param num      ڴ
 *  \param elm_size ÿһڴĳߴ(ֽ)
 *  \param file ָڴԴļƣnullַβ
 *              NULL ʾԴļ(anony)
 *  \param line ڴԴк
 *
 *  \retutrn 
 *      ڴɹ£ָڴָ롣ڴ
 *      ʧܣNULL
 *
 *  \note
 *      ڴ治ʹʱheap_freeͷŷڴ档
 *      
 *      μ ANSI C  calloc calloc ֮ͬڲ
 *      calloc֤صĶڴʵַelm_size߽
 *      ϡ
 */
DSLIB_API void * heap_calloc (size_t num, size_t elm_size, 
                    const char * file, int line);

/*!
 *  \brief  ͷŶڴ
 *
 *  \param  mb  ָǰheap_alloc/heap_callocڴ档
 *
 *  \return 
 *      ޡ
 */
DSLIB_API void heap_free (void * mb);

/*!
 *  \brief  ڴ
 *
 *  ñڴ׷ӵķʽָļС
 *
 *  \param fname ڴ䱨潫ļСfnameNULL
 *              򱨸潫׼ϡ
 *
 *  \retval -1 ʧܡ
 *  \retval 0  óɹ
 */
DSLIB_API int heap_report (const char * fname);

/*
 *  ڴͷź궨, Ϊ˷ʹ߶ṩЩ궨塣
 *
 *  1. HEAP_MALLOC(_size)
 *  2. HEAP_CALLOC(_num, _elm_size)
 *  3. HEAP_FREE(_mb)
 */
#define HEAP_MALLOC(_size)  heap_malloc((_size), __FILE__, __LINE__)

#define HEAP_CALLOC(_num, _elm_size)    heap_calloc((_num), (_elm_size), __FILE__, __LINE__)

#define HEAP_FREE(_mb) do{if(_mb) {heap_free((_mb)); (_mb) = NULL;}} while(0)

#ifdef DISABLE_OS_HEAP
  #undef HEAP_MALLOC
  #undef HEAP_CALLOC
  #undef HEAP_FREE

  #define HEAP_MALLOC(_size)            malloc(_size)
  
  #define HEAP_CALLOC(_num, _elm_size)  calloc(_num, _elm_size)
  
  #define HEAP_FREE(_mb) do {if (_mb) {free(_mb); (_mb) = NULL;}} while(0)

#endif

#endif /* __OS_HEAP_H_ASDFJLCXJVZXHCROEYUIODFGFMHFOIUHSDIHFZXKJCHGVLSDHFAJD */
