/************************************************************************************
 *
 *	Copyright (C) 2004-2005 SCADA Control Technology  Co., Ltd. 
 *  All rights reserved.
 *
 *  ļƣbuban101.h
 *  ļʶ101Լ
 *  ժ    Ҫ101ԼĴĽṹ껹к
 *
 *  ǰ汾1.0
 *      ߣaaawen
 *  ڣ2005/09/08
 *
 *  ȡ汾1.0
 *  ԭ  
 *  ڣ
 *
 *  ˵    ݶ
 *            u8		--- BYTE(usigned char)
 *            ch		--- char
 *            w			--- WORD(u_short, usigned short)
 *            sh		--- short
 *            b			--- BOOL(bool)
 *            i			--- int
 *            l			--- long
 *            u32		--- u_32
 *            ui		--- unsigned int(u_int)
 *            ul		--- unsigned long(u_long)
 *            f			--- float
 *            db		--- double
 *            c			--- class
 *            s			--- struct
 *            sta		--- static
 *            g			--- ȫֱ
 *            Array		--- 
 *            a		    --- 
 *			  m_		--- ݳԱ
 *            p			--- ָ
 *			  str		--- ַ
 *            ȫд	--- 
 *            ֽڱд--- ƣṹ 
 **************************************************************************************/
// buban101.h: interface for the buban101 class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(_BUBAN101_H_200509081012__INCLUDED_)
#define _BUBAN101_H_200509081012__INCLUDED_
#ifdef OS_LINUX
#include "baohulib/common.h"
#else
#include "common.h"
#endif

//////////////////////////////////////////////////////////////////////////
//							궨									    //
//						WEN 2005.09.08									//
//////////////////////////////////////////////////////////////////////////
//Ϣַ
#define		INFO_DI_BASEADDR			0x001		// ,˫ң
#define		INFO_PROTECT_BASEADDR		0x401		// ¼Ϣ
#define		INFO_PROTECT_STARTBASEADDR	0x501		// ¼
#define		INFO_PROTECT_GROUPBASEADDR	0x601		// ·Ϣ
#define		INFO_AI_BASEADDR			0x701		// ң
#define		INFO_PARA_BASEADDR			0x901		// ַ,ңһһӦ
#define		INFO_YKYT_BASEADDR			0xB01		// ңءң
#define		INFO_SET_BASEADDR			0xB81		// 趨ַΧ
#define		INFO_PI_BASEADDR			0xC01		// 
#define		INFO_STEP_BASEADDR			0xC81		// (:ѹֽͷ)
#define		INFO_BIN_BASEADDR			0xCA1		// ״̬Ϣ
#define		INFO_BCD_BASEADDR			0xCC1		// BCD(ˮλ,Ƶ)
#define		INFO_STATUS_BASEADDR		0xCE9		// վԶն״̬
#define		INFO_FILE_BASEADDR			0xCEA		// ļ

//һеĸ
#define		MAX_GROUP_AINUM				128
//#define		MAX_GROUP_FLOATAINUM		128
#define		MAX_GROUP_DINUM				128
#define		MAX_GROUP_PINUM				32

//ת͵ݵ
#define		MAX_AINUM					120
#define		MAX_FLOATAINUM				48
#define		MAX_DINUM					127
#define		MAX_PINUM					35

#define		MAX_POLL_CMD_BUF_NUM		32				// Ŀ

// Ͷ
#define     ASK_LINK                    0		// · 
#define		RST_LINK					1		// λ·
#define		RTU_TIME					2		// ʱʱ
#define     ASK_DI_DATA                 3		// ٻ2 YX
#define     ASK_AI_DATA                 4		// ٻ2 YC
#define     ASK_PI_DATA                 5		// ٻ2 YM
#define     ASK_ALL_DATA                6		// ʼٻ

#define     ASK_FIRST_DATA              7		// ٻ1 
#define     ASK_SECOND_DATA				8		// ٻ2 
#define		ACK							9		// ȷϻش
#define		ANS_LINK					10		// ·ش
#define     ASK_PI		                11		// ٻYM

#define		ASK_DATA_NO					12		// 
#define		ASK_ALLDATA_END				13		// ٻݽ(ٻ͵ٻ)
//#define	ASK_ALLDATA_ACK				14		// ٻȷ(ٻ͵ٻ)

// ʱٻ
#define		BUBAN101_TIMER_CMD_NUM		2		// Ŀ
#define		MAX_POLLCMD_BUF_LEN			320		// Ŀ

// ģʽ
#define		CONTROL_DOUBLE				0		// ˫
#define		CONTROL_SINGAL				1		// 
#define		CONTROL_DIRECT				2		// ֱӿ

// Լ汾
#define		VER_BUBAN_101				0		// 101
#define		VER_IEC870_5_101			1		// IEC101
/////////////////////////////ṹ/////////////////////////////////
typedef struct
{
    long	CmdTimerCnt;
    long	CmdTimerConst;
} BUBAN101CMDDEF;

typedef struct tagBUBAN101PORTPARAM
{
	BOOL        RstLinkOk;		// ʼʱFALSE
	BOOL        LinkOk;			// վʼ־ 1:ok; 0:no ʼʱFALSE
	BOOL        Initdata;       // ʼٻ־ TRUEյٻ֡
												 // FALSEδյٻ֡
								// ٻȱ־ TRUEյٻ֡
		                                     // FALSEδյٻ֡
	BYTE        LinkAddr;		// ַ
	BYTE		CtlByte;		// Ϣ
	
	long		LinkOkCnt;
	long		lTimeOutConst;	// ʱʱ

	short		RtuVersion;		// 汾

	short		BalanceOrNot;	//Ƿƽʽ =1:ok; =0:no

	short		CurCmdIdx;
	short		YkMode;			// ңطʽ(=0˫ңأ=1ңأ=2ֱطʽ)

	// wen 2005.01.15 ޸Ϣʼַ
	int			iAiBaseAddr;	//ңʼַ
	int			iDiBaseAddr;	//ңʼַ
	int			iPiBaseAddr;	//ңʼַ
	int			iYkBaseAddr;	//ңʼַ

	BYTE		m_au8RecvBuf[300];
	int			m_iRecvLen;

	BUBAN101CMDDEF	CmdTime[BUBAN101_TIMER_CMD_NUM];

	SIO_PARAM_BAOHU_DEF *m_psBaoHu;						// ùԼĶ˿ָ
} BUBAN101PORTPARAM, *pBUBAN101PORTPARAM;

/////////////////////////Ϊͨúӿ///////////////////////////
/*!
	\brief ȡú
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban101ReadConfig(int commid);				// ʼ
/*!
	\brief ȡ˿ݺ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
	\param buf -- Դָ
	\param len -- Դ	
 */
void Buban101RecvData(int commid, u_char *buf, int len);// Լݴ
/*!
	\brief Լݴʱ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban101Timer(int commid);							// ʱ
/*!
	\brief ңңݴ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
	\param buf -- Դָ
	\param len -- Դ	
 */
void Buban101YkYtProcess(int commid, u_char *buf, int len);		// ңң
/*!
	\brief ϵͳ·ʱ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban101SendSystemTime(int commid);					// ϵͳʱ
/*!
	\brief ϵͳ˳ʱԼ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban101Exit(int commid);					// Լ˳
/*!
	\brief 
	\param commid -- ˿ں
	\param rtumsg -- ·ıָ
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
 */
void Buban101BaoHuCmdProcess(int commid, RTUMSG *rtumsg, BOOL bUpData);
/*!
	\brief ȡݿָ뺯
	\param commid    -- ˿ں
	\param iProvAddr -- ͳһŵıתַ
	\param ppBaoHuDB -- űָָ
	\retval          -- ظװñ
 */
int Buban101GetBaohuDataBase(int commid, int iProvAddr, GROUPDEF **ppBaoHuDB);
/////////////////////////ͨúӿڽ///////////////////////////////

/////////////////////////buban101ӿ///////////////////////////
// У֡Ƿȷ
BOOL Buban101Check(u_char* msg, int len);
// Buban101 ۼӺͼ
u_char CalBuban101Lpc(u_char* msg, int len);
//ָʼ
void InitBuban101CommandBuffer(int commid);
/////////////////////////buban101ӿڽ///////////////////////

/////////////////////////Ϊͨúֽ֧ӿ/////////////////////////
void Buban101ProvMakeYkYtCommand(int commid, u_char *buf, int len);
/////////////////////////ͨúֽ֧ӿڽ///////////////////////////

///////////////////////////Ϊָɺ///////////////////////////
// Buban101  
void MakeBuban101Command(u_32 commid, u_char cmdidx);
//ңңָ
void MakeBuBan101YkYtCommand(u_32 commid, u_char *buf, int len);
///////////////////////////ָɺ/////////////////////////////

/////////////////////ΪPOLLINGԼ溯ӿ//////////////////////
void Buban101FindNextCmd(int commid);
BOOL Buban101FindNextCmdEx(int commid);
void Buban101SendCmdFormPollCmdBuf(int commid);
//////////////////////POLLINGԼ溯ӿڽ///////////////////////

///////////////////////ΪԼӿ///////////////////////////
//======================Ϊվݴ============================
void Buban101ProcessData(u_32 commid, BUBAN101PORTPARAM *psPortParam, BOOL bProcess);
void Buban101shortprocess(RTUMSG *rtumsg);
void Buban101longprocess(RTUMSG *rtumsg);
void Buban101NoChanged(RTUMSG * rtumsg);

//Buban101 ʼݴ
void Buban101InitdataProecss(RTUMSG * rtumsg);
//Ƚ֡
void Buban101PidataEnd(RTUMSG * rtumsg);
//趨ȷ
void Buban101SetAck(RTUMSG *rtumsg);
//Buban101 ңңУ
void Buban101YkYtAck(RTUMSG * rtumsg);
//Buban101 ʱ
void Buban101SynTime(RTUMSG * rtumsg);

// վңűλ֡
void Buban101AutoSendDiProcess(RTUMSG *rtumsg);

void Buban101AiWithPzDataProcess(RTUMSG *, int);
void Buban101AllAiDataProcess(RTUMSG *rtumsg);
void Buban101DiDataProcess(RTUMSG *rtumsg, int);
void Buban101SoeDataProcess(RTUMSG *rtumsg, int);
void Buban101PiDataProcess(RTUMSG * rtumsg);
void Buban101PiWithTimeDataProcess(RTUMSG *rtumsg);

//ݴ
void Buban101BaoHuDataProcess(RTUMSG *rtumsg);
void Buban101DefaultBaoHuDataProcess(RTUMSG *rtumsg);

//  7 BYTE ʱ
void Buban101SoeDataProcessWithCP56Time2a(RTUMSG *rtumsg, int flag);
void Buban101AiWithDataProcessWithM_ME_TD_1(RTUMSG * rtumsg);
void Buban101AiWithDataProcessWithM_ME_TE_1(RTUMSG * rtumsg);
void Buban101AiWithDataProcessWithM_ME_TF_1(RTUMSG * rtumsg);
void Buban101PiWithTimeDataProcessWithM_IT_TB_1(RTUMSG *rtumsg);

//======================Ϊվݴ============================
void ProvBuban101dataProcess(int commid, RTUMSG *rtumsg);
void ProvBuban101shortprocess(int commid, RTUMSG * rtumsg);
void ProvBuban101longprocess(int commid, RTUMSG * rtumsg);
void ProvBuban101SendAllData(int commid, RTUMSG * rtumsg);
void ProvBuban101SendPIData(int commid, RTUMSG * rtumsg);
void ProvBuban101ProcessTime(int commid, RTUMSG *rtumsg);
//iGroupNo=0ΪӦٻ
void ProvBuban101SendPI(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban101SendAI(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban101SendDI(int commid, RTUMSG *rtumsg, int iGroupNo);

void ProvBuban101YkYtData(int commid, RTUMSG *rtumsg);
void MakeProvBuban101YkYtAckMsg(int commid, int pnt, int op, int step);

void ProvBuban101SendClass1(int commid);
void ProvBuban101SendClass2(int commid);
void ProvMakeBuban101Command(int commid, u_char cmdidx);
/////////////////////////Լӿڽ///////////////////////////

#endif // !defined(_BUBAN101_H_200509081012__INCLUDED_)
