/************************************************************************************
 *
 *	Copyright (C) 2004-2005 SCADA Control Technology  Co., Ltd. 
 *  All rights reserved.
 *
 *  ļƣbuban104.h
 *  ļʶ104Լ
 *  ժ    Ҫ104ԼĴĽṹ껹к
 *
 *  ǰ汾1.0
 *      ߣaaawen
 *  ڣ2005/09/14
 *
 *  ȡ汾1.0
 *  ԭ  
 *  ڣ
 *
 *  ˵    ݶ
 *            u8		--- BYTE(usigned char)
 *            ch		--- char
 *            w			--- WORD(u_short, usigned short)
 *            sh		--- short
 *            b			--- BOOL(bool)
 *            i			--- int
 *            l			--- long
 *            u32		--- u_32
 *            ui		--- unsigned int(u_int)
 *            ul		--- unsigned long(u_long)
 *            f			--- float
 *            db		--- double
 *            c			--- class
 *            s			--- struct
 *            sta		--- static
 *            g			--- ȫֱ
 *            Array		--- 
 *            a		    --- 
 *			  m_		--- ݳԱ
 *            p			--- ָ
 *			  str		--- ַ
 *            ȫд	--- 
 *            ֽڱд--- ƣṹ 
 **************************************************************************************/
// buban104.h: interface for the buban104 class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(_BUBAN104_H_200509141152__INCLUDED_)
#define _BUBAN104_H_200509141152__INCLUDED_
#ifdef OS_LINUX
#include "baohulib/common.h"
#else
#include "common.h"
#endif

//////////////////////////////////////////////////////////////////////////
//							궨									    //
//						WEN 2005.09.08									//
//////////////////////////////////////////////////////////////////////////
#define		MAX_104_PINUM				30

#define		FORMAT_I					14		// I-ʽ
#define		FORMAT_S					15		// S-ʽ
#define		FORMAT_U_START_ACT			16		// U-ʽ
#define		FORMAT_U_START_CON			17		// U-ʽӦ
#define		FORMAT_U_STOP_ACT			18		// U-ʽֹͣ
#define		FORMAT_U_STOP_CON			19		// U-ʽֹͣӦ
#define		FORMAT_U_TEST_ACT			20		// U-ʽ
#define		FORMAT_U_TEST_CON			21		// U-ʽӦ

// ʱٻ
#define		BUBAN104_TIMER_CMD_NUM		3		// Ŀ
#define		MAX_SEQUENCE				0x7fff	// ֡

#define		MAX_FRAMEMATCHING_SIZE		2		// ֡ƥߴ

// Լ汾
#define		VER_BUBAN_104				0		// 104
#define		VER_IEC870_5_104			1		// IEC104
/////////////////////////////ṹ/////////////////////////////////
typedef struct
{
    long	CmdTimerCnt;
    long	CmdTimerConst;
} BUBAN104CMDDEF;

typedef struct tagBUBAN104PORTPARAM
{
	BOOL        LinkOk;			// վʼ־ 1:ok; 0:no ʼʱFALSE
	BOOL        Initdata;       // ʼٻ־ TRUEյٻ֡
												 // FALSEδյٻ֡
								// ٻȱ־ TRUEյٻ֡
		                                     // FALSEδյٻ֡
	WORD        wLinkAddr;		// ַ
	
	WORD		wSendSequence;	// ֡
	WORD		wRecvSequence;	// ֡
	WORD		wAckSequence;	// Ӧ֡
	BOOL		bAckRight;		// Ӧ֡Ƿͬ (վЧ)
	BOOL		bStopComm;		// ͨѶֹͣ

	BOOL		bSendFormatI;
	BYTE		ProvAckOrNot;	// תǷҪӦ

	long		lTimeOutSendTest;// ʱͲ֡
	long		lTimeOutConst;	// ʱʱ
	long		lTimeOutCnt;	// ʱʱ
	long		lYkYtAckTimeConst;// Уʱʱ
	long		lYkYtAckTime;	// Уʱʱ
	BOOL		bCloseSocket;	// رsocket˿
	char		YkCmdBuf[32];	// ңӳٷͷУ
	long		lYkCmdBuflen;	// ңӳٷͷУݳ

	long		m_lNoDataCnt;	// ʱ䣬ʱʱ䷢Ͳ֡

	short		RtuVersion;		// 汾
	int			m_iPublishYear;	// ʱ(ȱʡΪ2000)
	
	short		CurCmdIdx;
	short		YkMode;			// ңطʽ(=0˫ңأ=1ңأ=2ֱطʽ)

	// wen 2005.01.15 ޸Ϣʼַ
	int			iAiBaseAddr;	// ңʼַ
	int			iDiBaseAddr;	// ңʼַ
	int			iPiBaseAddr;	// ңʼַ
	int			iYkBaseAddr;	// ңʼַ

	BYTE		m_au8RecvBuf[300];
	int			m_iRecvLen;

	int			m_iFrameSize;	// ֡Ӧߴ

	BYTE		m_bProvAiType;	// תңͱʶ

	BUBAN104CMDDEF	CmdTime[BUBAN104_TIMER_CMD_NUM];

	SIO_PARAM_BAOHU_DEF *m_psBaoHu;						// ùԼĶ˿ָ
} BUBAN104PORTPARAM, *pBUBAN104PORTPARAM;

/////////////////////////Ϊͨúӿ///////////////////////////
/*!
	\brief ȡú
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban104ReadConfig(int commid);				// ʼ
/*!
	\brief ȡ˿ݺ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
	\param buf -- Դָ
	\param len -- Դ	
 */
void Buban104RecvData(int commid, u_char *buf, int len);// Լݴ
/*!
	\brief Լݴʱ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban104Timer(int commid);							// ʱ
/*!
	\brief ңңݴ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
	\param buf -- Դָ
	\param len -- Դ	
 */
void Buban104YkYtProcess(int commid, u_char *buf, int len);		// ңң
/*!
	\brief ϵͳ·ʱ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban104SendSystemTime(int commid);					// ϵͳʱ
/*!
	\brief ϵͳ˳ʱԼ
	\param commid -- ˿ں
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n	
 */
void Buban104Exit(int commid);					// Լ˳
/*!
	\brief 
	\param commid -- ˿ں
	\param rtumsg -- ·ıָ
	\note
	    ȡֵΧ0 -- MaxSerialPortNum + MaxNetPortNum -1\n
 */
void Buban104BaoHuCmdProcess(int commid, RTUMSG *rtumsg, BOOL bUpData);
/*!
	\brief ȡݿָ뺯
	\param commid    -- ˿ں
	\param iProvAddr -- ͳһŵıתַ
	\param ppBaoHuDB -- űָָ
	\retval          -- ظװñ
 */
int Buban104GetBaohuDataBase(int commid, int iProvAddr, GROUPDEF **ppBaoHuDB);
/////////////////////////ͨúӿڽ///////////////////////////////

/////////////////////////buban104ӿ///////////////////////////
//ָʼ
void InitBuban104CommandBuffer(int commid);
//رsocketͨѶ
void Buban104CloseSocket(u_32 commid);
/////////////////////////buban104ӿڽ///////////////////////

/////////////////////////Ϊͨúֽ֧ӿ/////////////////////////
void Buban104ProvMakeYkYtCommand(int commid, u_char *buf, int len);
/////////////////////////ͨúֽ֧ӿڽ///////////////////////////

///////////////////////////Ϊָɺ///////////////////////////
// Buban104 ?
void MakeBuban104Command(u_32 commid, u_char cmdidx);
//ңңָ
void MakeBuBan104YkYtCommand(u_32 commid, u_char *buf, int len);
///////////////////////////ָɺ/////////////////////////////

/////////////////////ΪPOLLINGԼ溯ӿ//////////////////////
void Buban104FindNextCmd(int commid);
void Buban104FindNextProvCmd(int commid);
void Buban104SendCmdFormPollCmdBuf(int commid);
//////////////////////POLLINGԼ溯ӿڽ///////////////////////

///////////////////////ΪԼӿ///////////////////////////
//======================Ϊվݴ============================
void Buban104ProcessData(u_32 commid, BUBAN104PORTPARAM *psPortParam, BOOL bProcess);
//ݸʽI
void Buban104FormatI(RTUMSG *rtumsg);
//ݸʽU
void Buban104FormatU(RTUMSG *rtumsg);

//Buban104 ʼݴ
void Buban104InitdataProecss(RTUMSG * rtumsg);
//Ƚ֡
void Buban104PidataEnd(RTUMSG * rtumsg);
//趨ȷ
void Buban104SetAck(RTUMSG *rtumsg);
//Buban104 ңңУ
void Buban104YkYtAck(RTUMSG * rtumsg);
//Buban104 ʱ
void Buban104SynTime(RTUMSG * rtumsg);

// վңűλ֡
void Buban104AutoSendDiProcess(RTUMSG *rtumsg);

void Buban104AiWithPzDataProcess(RTUMSG *, int);
void Buban104AllAiDataProcess(RTUMSG *rtumsg);
void Buban104AllFloatAiDataProcess(RTUMSG *rtumsg);
void Buban104DiDataProcess(RTUMSG *rtumsg, int);
void Buban104SoeDataProcess(RTUMSG *rtumsg, int);
void Buban104PiDataProcess(RTUMSG * rtumsg);
void Buban104PiWithTimeDataProcess(RTUMSG *rtumsg);

//ݴ
void Buban104BaoHuDataProcess(RTUMSG *rtumsg);
void Buban104DefaultBaoHuDataProcess(RTUMSG *rtumsg);

//  7 BYTE ʱ
void Buban104SoeDataProcessWithCP56Time2a(RTUMSG *rtumsg, int flag);
void Buban104AiWithDataProcessWithM_ME_TD_1(RTUMSG * rtumsg);
void Buban104AiWithDataProcessWithM_ME_TE_1(RTUMSG * rtumsg);
void Buban104AiWithDataProcessWithM_ME_TF_1(RTUMSG * rtumsg);
void Buban104PiWithTimeDataProcessWithM_IT_TB_1(RTUMSG *rtumsg);

//======================Ϊվݴ============================
void ProvBuban104dataProcess(int commid, RTUMSG *rtumsg);
void ProvBuban104FormatI(int commid, RTUMSG *rtumsg);
void ProvBuban104FormatU(int commid, RTUMSG *rtumsg);
void ProvBuban104FormatS(int commid, RTUMSG *rtumsg);
void ProvBuban104SendAllData(int commid, RTUMSG *rtumsg);
void ProvBuban104SendPIData(int commid, RTUMSG *rtumsg);
void ProvBuban104ProcessTime(int commid, RTUMSG *rtumsg);
//iGroupNo=0ΪӦٻ
void ProvBuban104SendPI(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban104SendAI(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban104SendDI(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban104SendSoe(int commid);
void ProvBuban104YkYtData(int commid, RTUMSG *rtumsg);
void MakeProvBuban104YkYtAckMsg(int commid, int pnt, int op, int step);

void ProvBuban104SendClass1(int commid);
void ProvBuban104SendClass2(int commid);
void ProvMakeBuban104Command(int commid, u_char cmdidx);

void ProvBuban104SendAIwithFloat(int commid, RTUMSG *rtumsg, int iGroupNo);
void ProvBuban104SendClass2withFloat(int commid);
/////////////////////////Լӿڽ///////////////////////////
#endif // !defined(_BUBAN104_H_200509141152__INCLUDED_)
