//////////////////////////////////////////////////////////////////////
#if !defined(_CHAINLIST_H_AAAWEN_200505271056__INCLUDED_)
#define _CHAINLIST_H_AAAWEN_200505271056__INCLUDED_

#include "basetype.h"

// 
typedef struct tagSINGLELISTUNIT
{
	int					iLen;	// ݳ
	BYTE				*pBuf;	// 洢
	struct tagSINGLELISTUNIT	*pNext;	// һ
}SINGLELISTUNIT;

typedef struct tagSINGLELIST
{
	int				iDevId;	// ˿ں(2ֽΪ˿ں, 2ֽΪװú)
	int				iNum;
	int				iMaxNum;
	SINGLELISTUNIT	*pHead;
	SINGLELISTUNIT	*pTail;	
}SINGLELIST;

typedef struct tagDOUBLELISTUNIT
{
	int					iDataLen;	// ݳ
	BYTE				*pDataBuf;	// 洢
	struct tagDOUBLELISTUNIT	*pNext;		// ˫һ
	struct tagDOUBLELISTUNIT	*pFore;		// ˫ǰһ
}DOUBLELISTUNIT;

typedef struct tagDOUBLELIST
{
	int				iNum;
	int				iMaxNum;
	DOUBLELISTUNIT	*pHead;
	DOUBLELISTUNIT	*pTail;	
}DOUBLELIST;

// SingleList
DSLIB_API void SingleListInit(SINGLELIST *psSingleList, int iMaxNum);
DSLIB_API void SingleListInitEx(SINGLELIST *psSingleList, int iMaxNum, int iDevId);
DSLIB_API int  SingleListHaveData(SINGLELIST *psSingleList);
DSLIB_API BOOL SingleListAddData(SINGLELIST *psSingleList, BYTE *pu8Data, int iDataLen);
DSLIB_API int  SingleListGetAndDelData(SINGLELIST *psSingleList, BYTE *pu8Data, int iMaxLen);
DSLIB_API BOOL SingleListDelData(SINGLELIST *psSingleList);
DSLIB_API BOOL SingleListDelAllData(SINGLELIST *psSingleList);

#endif // !defined(_CHAINLIST_H_AAAWEN_200505271056__INCLUDED_)
