



#if	!defined(__CONFRW_H__QWERUOIPUADFJHAFKLHADSFHADSFVCMBVZXCVQOEWIRADSHJKXZJVBLWQERYO)
#define	__CONFRW_H__QWERUOIPUADFJHAFKLHADSFHADSFVCMBVZXCVQOEWIRADSHJKXZJVBLWQERYO

/*!
 *	\if developer_doc
 *		\file 
 *	
 *		\brief  ļĵýӿͷļ,:ϵͳֵ, ⲿӿںͷļ
 *
 *		id: $Id: confrw.h,v 1.2 2006/08/04 03:37:33 zhuzhenhua Exp $
 *
 *		\author С prcharold@sina.com.cn develop1@szscada.com 
 *	\endif
*/


//#include <util/util.h>
#include "confrw_errno.h"

#ifndef _WIN32
#define CONFRWLIB_API
#else
#ifdef CONFRWLIB_EXPORTS
	#define CONFRWLIB_API __declspec(dllexport)
#else
	#define CONFRWLIB_API __declspec(dllimport)
#endif// CONFRWLIB_EXPORTS
#endif// _WIN32

/*!
*	\if by_group
*		\addtogroup grp_config_rw
*		@{
*	\endif
*/

/*!
 *	\brief	ļ, رʾļľ
 *
 *	\param	pszfname	--[in]	ļȫ·(ĬΪ char [MAX_PATH])
 *	\param	ppvhandle	--[in]	ںִгɹ, ļ(Ļ)
 *
 *	\retval	ֵ
 *	\retval	SUCCESS	--	ɹִ˸ú, ˸ļ
 *	\retval		--	ʧܴ
 *
 */
CONFRWLIB_API int conf_open ( const char * pszfname, void ** ppvhandle );






/*!
 *	\brief	رļ
 *
 *	\param	handle	--[in]	ļ
 *	
 *	\retval	SUCCESS	--	ɹĹرָļ(Դͷŵȹ)
 *	\retval	ERROR_CONF_HANLDE	--	ļд
 *	\retval		--	ʧܴ
 *
 *	\note
 *		Ĳļ(), κ.
 *
 */
CONFRWLIB_API int	conf_close ( void * handle );





/*!
 *	\brief	ָ [], ȡļе
 *
 *	\param	handle		--[in]	ļ
 *	\param	pszsec_name	--[in]	, nullַβַ
 *	\param	pszkey_name	--[in]	, nullַβַ
 *	\param	pszdefault	--[in]	Ĭֵ, nullַβַ,ļûиü, ͬʱ, òΪ, 򷵻ظֵ
 *	\param	pbuf		--[out]	ֵĻ
 *	\param	buffer_length	--[in]	
 *	
 *	\retval	SUCCESS	--	õļֵ, ҳɹض
 *	\retval	Ĭֵ, ȡļֵ/ڵ, ͬSUCCESS
 *	\retval	ERROR_CONF_SECTION	--	ȡļڵĶβ
 *	\retval	ERROR_CONF_KEY		--	ȡļ
 *	\retval		--	ʧܴ
 */
CONFRWLIB_API int conf_read_key ( void * handle, 
					const char * pszsec_name, 
					const char * pszkey_name,
					const char * pszdefault,
					char * pbuf,
					int buffer_length );






/*!
 *	\brief	޸/һµ
 *
 *	\param	handle			--[in]	ļ
 *	\param	pszsec_name		--[in]	
 *	\param	pszkey_name		--[in]	
 *	\param	pszkey_value	--[in]	ֵ
 *	\param	force_insert	--[in]	(, ), ǷҪ(, )ֵ,
 *							ò0, 򲻲, , .
 *	
 *	\retval	SUCCESS	--	ɹ
 *	\retval		--	ʧܴ
 *	
 *	\note
 *		 force_insert Ϊ0, ļвָʱ,  ERROR_CONF_SECTION;
 *		ָ(/)ʱ,  ERROR_CONF_KEY.
 */
CONFRWLIB_API int conf_write_key ( void * handle,
					const char * pszsec_name,
					const char * pszkey_name,
					const char * pszkey_value,
					int force_insert );

 



/*!
 *	\brief	ļɾһָ(, )
 *
 *	\param	handle		--[in]	ļ
 *	\param	pszsec_name	--[in]	
 *	\param	pszkey_name	--[in]	
 *	
 *	\retval	SUCCESS	--	ɹɾָ
 *	\retval		--	ʧܴ
 *
 *	\note
 *		ָĶβ, 򷵻 ERROR_CONF_SECTION
 *		ָ(, )ϲ, 򷵻 ERROR_CONF_KEY
 */
CONFRWLIB_API int conf_delete_key ( void * handle,
						const char * pszsec_name,
						const char * pszkey_name );





/*!
 *	\brief	ɾļһε
 *
 *	\param	handle		--[in]	ļ
 *	\param	pszsec_name	--[in]	ϣɾĶε, nullַβַ
 *
 *	\retval	SUCCESS	--	ɹɾļеָĶ
 *	\retval		--	ʧܴ
 *
 *	\note
 *		ָĶβ, 򷵻 ERROR_CONF_SECTION
 */
CONFRWLIB_API int conf_delete_section ( void * handle,
							const char * pszsec_name );

/*!
*	\if by_group
*		@}
*	\endif
*/


#endif	//!defined(__CONFRW_H__QWERUOIPUADFJHAFKLHADSFHADSFVCMBVZXCVQOEWIRADSHJKXZJVBLWQERYO)
