/************************************************************************************
 *
 *	Copyright (C) 2002-2003 SCADA Control Technology  Co., Ltd. All rights reserved.
 *
 *  $Source: /opt/CVS_ROOT_PGC_EX2000/commserver/windows/widgets/tcphost.h,v $
 *
 *  $Author: jehu $
 *
 *  $Date: 2006/07/05 07:31:44 $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  $State: Exp $
 *
 *  $Name:  $
 *
 *  $Locker:  $
 *
 *  $Log: tcphost.h,v $
 *  Revision 1.1.1.1  2006/07/05 07:31:44  jehu
 *  no message
 *
 *  Revision 1.5  2006/05/26 10:38:03  administrator
 *  32λģ
 *
 *  Revision 1.4  2006/04/22 07:49:26  administrator
 *  ӵĴϢֶ֧˿ͨѶʱлӳɹ㷨
 *
 *  Revision 1.2  2006/01/17 06:14:53  Administrator
 *  ӶʱװòԼ˿ںƫ
 *
 *  Revision 1.1  2005/10/20 06:20:34  Administrator
 *  ǰû
 *
 *  Revision 1.1  2005/10/12 06:03:46  Administrator
 *  ǰû
 *
 *
 **************************************************************************************/
//***************************************************************
//*							TcpHost.h							*
//*					Liangchu Lee 1999.12.20						*
//***************************************************************

#ifndef 	__TCPHOST_H_ICL__
#define		__TCPHOST_H_ICL__

#include        "common.h"

// һǰûװpcds-3116
#define			FEND_OTHERDEV_DS3116	1

#define			HOST_CLOSE_NET			1
#define			OVER_TIME_CLOSE_NET		2
#define			FEND_CLOSE_NET			3
#define			ERROR_CLOSE_NET			4

#define			CHECK_VERSION_FLAG		1

// зʽʽ
#define			RUN_MODE_STANDBY		0
// зʽͬʱ
#define			RUN_MODE_ALLHOT			1

//**************** ˿ ************************
#define 	iCOMM_DATA       		0x10            // RTUݰ

//************ ǰû -->   ****************
#define		iREQUESTHOSTSTATUS		0x14 			// ״̬
#define		iTIMEINFORM				0x2c			// ǰûʱ
#define	 	iAIDATA					0x31			// 仯ң
#define	 	iDIDATA					0x32            // 仯ң
#define	 	iPIDATA					0x33			// 仯
#define	 	iSOEDATA				0x34            // SOE 
#define	 	iACKDATA				0x35            // ңңУ

#define		WUXI_ZHUANFA_AI_TO_HOST		0x36
#define		WUXI_ZHUANFA_DI_TO_HOST		iDIALLDATA
#define		WUXI_ZHUANFA_PI_TO_HOST		0x37

#define	 	iODDATA					0x38            // ң
#define	 	iODALLDATA				0x39            // ңȫ
#define		iWUFANGYKYTREQ			0x3d			// ңң

#define	 	iAIALLDATA				0x40            // ңȫ
#define	 	iDIALLDATA				0x41            // ңȫ
#define	 	iPIALLDATA				0x42            // ȫ
// wen 2006.05.20 32bitģ
#define		PGC3_AI32DATA			0x45			// 仯32λң
#define		PGC3_AI32ALLDATA		0x46			// ң32λȫ

#define	 	iBYPASSDATA				0x50            // ֱͨ

#define	 	iODPOINT				0x81            // 
#define	 	iANPOINT				0x82            // ģ
#define	 	iDIPOINT				0x83            // 
#define	 	iLINESTATUS				0x84            // ˿·״̬
#define		iNETTESTMSG				0xf0			// ״̬
#define		iNETNAMEPLATE			0xef			// ʾ

//************  --> ǰû  ****************
#define	 	hHOSTSTATUS				0x15            // ״̬
#define		NET_PROFILE_UPDATE		0x1B			// ·ݿָ
#define		hTIMEINFORM				0x2c			// ʱ
#define	 	hYKYTCMD				0x35            // ңң
#define	 	hBYPASSCMD				0x50            // ֱͨ
#define	 	hMAPANDATA				0x82            // ģ
#define	 	hMAPDIDATA				0x83            // 
#define		hDATA_OUTPUT_CTRL		0x85			// 
#define		hRELOADDATABASE			0x86			// װݿ
#define		hNETTESTMSG				0xf0			// ״̬
#define		hMAPALLOP				0xf4			// ģȫ̲


//*********************ݻ************************
#define		AIMSGNO					0
#define		DIMSGNO					1
#define		SOEMSGNO				2
#define		YKYTACKNO				3
#define		ODMSGNO					4
#define		PIMSGNO					5
#define		RTUCHANGMSGNUM			6

//******************************************************

typedef struct tagTCP_SEND_DATA_BUF
{
	int		MsgLen							__attribute__ ((packed));
    BYTE	MsgData[MAX_NET_BUF]			__attribute__ ((packed));
} TCP_SEND_DATA_BUF;

typedef struct tagTCP_RCV_DATA_BUF
{
    int  		MsgCnt						__attribute__ ((packed));// Ϣݼ
    int			Front						__attribute__ ((packed));// Ϣȡָ
    int			Rear						__attribute__ ((packed));// Ϣָ
    BYTE   		MsgData[MAX_NET_BUF]		__attribute__ ((packed));// Ϣ
} TCP_RCV_DATA_BUF;

typedef struct tagFEND_DEF
{
    char			Name[MAX_MACHINE_NAME_LEN]							__attribute__ ((packed));
    int				FendIdx												__attribute__ ((packed));
	int				LinkFlag											__attribute__ ((packed));
	int				EnableLink											__attribute__ ((packed));
	char			SetTcpIpAddr[MAX_FEND*MAX_ADDR][TCPIP_ADDR_LEN]		__attribute__ ((packed));
	char			TcpIpAddr[MAX_ADDR][TCPIP_ADDR_LEN]					__attribute__ ((packed));
	u_long			HostIpAddr[MAX_ADDR]								__attribute__ ((packed));
	u_long			AllIpAddr[MAX_ADDR]									__attribute__ ((packed));
	u_long			BroadCastAddr[MAX_ADDR]								__attribute__ ((packed));
	int				LinkStatus[MAX_FEND]								__attribute__ ((packed));
	int				LinkCnt[MAX_FEND]									__attribute__ ((packed));
	
	int				FendExistFlag[MAX_FEND]								__attribute__ ((packed));
	int				FendExistCnt[MAX_FEND]								__attribute__ ((packed));

	int				SendTxdDataFlag[MAX_FEND]							__attribute__ ((packed));

	// wen 2006.01.14 װõʼվŵƫ
	int				iPortOffset											__attribute__ ((packed));
	int				iRunMode											__attribute__ ((packed));
	
	// wen 2006.04.22 лʱжϵĶ˿ͨѶ״̬(λ)
	int				iPortMask											__attribute__ ((packed));

	// wen 2006.05.20 32bitģ
	int				iSendAiof32Bit										__attribute__ ((packed));
} FEND_DEF;

typedef struct tagTCP_LINK_DEF
{
    u_char			InitFlag											__attribute__ ((packed));// ʼ־
    u_char			InitOk												__attribute__ ((packed));// ʼɹ־
	long			InitLinkCnt											__attribute__ ((packed));// ʼ

    char  			ExistFlag											__attribute__ ((packed));// ڱ־
    u_char  		CommFlag											__attribute__ ((packed));// ͨѶ־
    u_char			Status												__attribute__ ((packed));// ״̬
    long    		StatusCnt											__attribute__ ((packed));// ״̬
	SOCKET			SocketId											__attribute__ ((packed));// Ӻ
	
	u_char			LinkType											__attribute__ ((packed));// 
	
	char			CurLinkIdx											__attribute__ ((packed));
    u_char			TcpIpAddr[MAX_ADDR][TCPIP_ADDR_LEN]					__attribute__ ((packed));// Tcp/Ip ַ

	u_char			VersionFalgByte										__attribute__ ((packed));// 汾ű־
	int				RevHostStatusMsg									__attribute__ ((packed));// 㲥Ϣ

	char			NetNameplateFalg									__attribute__ ((packed));

	int				iNoWriteNum											__attribute__ ((packed));
} TCP_LINK_DEF;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ϵͳRTUMSGṹ
typedef struct tagORTUMSGHEAD
{
    u_char   		MsgType							__attribute__ ((packed));// Ϣ
    u_char	   		PortNumber						__attribute__ ((packed));// Ϣ˿ں
    short 			MsgLen							__attribute__ ((packed));// Ϣ
} ORTUMSGHEAD;

typedef struct tagORTUMSG
{
    u_char   		MsgType							__attribute__ ((packed));// Ϣ
    u_char	   		PortNumber						__attribute__ ((packed));// Ϣ˿ں
    short 			MsgLen							__attribute__ ((packed));// Ϣ
    u_char   		MsgData[MAX_RTU_MSG_SIZE]		__attribute__ ((packed));// Ϣ
} ORTUMSG;

typedef struct tagHOSTMSGHEAD
{
    WORD	   		MsgType							__attribute__ ((packed));// Ϣ
    WORD	   		PortNumber						__attribute__ ((packed));// Ϣ˿ں
    WORD 			MsgLen							__attribute__ ((packed));// Ϣ
	WORD	        EMsgLen							__attribute__ ((packed));// չϢ
} HOSTMSGHEAD;

typedef struct tagHOSTMSG
{
    WORD	   		MsgType							__attribute__ ((packed));// Ϣ
    WORD	   		PortNumber						__attribute__ ((packed));// Ϣ˿ں
    WORD 			MsgLen							__attribute__ ((packed));// Ϣ
	WORD	        EMsgLen							__attribute__ ((packed));// չϢ
    u_char   		MsgData[MAX_RTU_MSG_SIZE]		__attribute__ ((packed));// Ϣ
} HOSTMSG;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
BOOL GetConfigName(char *szFileName, int iFileNameLen, int IsPortConfig);
BOOL IsWouldBlock();
BOOL IsWouldBlockEx(int neterrno);
int  GetNetErrorNo();
void CloseNetSocket(SOCKET sock);
void ULongToIPString(char *ipstr, u_long ipulong);

void InitSetTcpIpAddr(void);

void SendNetNameplateMsgToHost(int flag);
BOOL InitFendMsg(void);
BOOL InitHostWSAStartup(void);
void FindCurrentFend(void);
void LinkOneHost(int hostid);
void HostConnect(SOCKET socket, WORD error);
void LinkToHost(void);
void CloseHostSocket(SOCKET socket, int flag);
void CloseHost(void);
BOOL ReadHost(int hostid);
int  GetHostMsgFormHostRevBuf(HOSTMSG *hostmsg, int hostid);
BOOL ReadDataFormHost(SOCKET socket);
int  SendDataToHostSendBuf(int hostid, u_char *buf, int len, BOOL bInsert);
void SendDataToAllHostSendBuf(u_char *buf, int len);
void SendHostSendBufToHost(void);
void ClearSendBuffer(int hostid);
void ClearRecvBuffer(int hostid);

// ݴ
void HostDataProceWithSignalYkYt(HOSTMSG *hmsg);
void HostDataProce(HOSTMSG *hostmsg);
void SendRtuChangeDataToHost(void);
void SendPortStatisticsToHost(void);
void SendPortStatusToHost(int flag);
void SendPortAllDataToHost(void);
void SetSoeData(int commidex, SOE_DEF *pSoeData);
void SetYkYtAckData(int portno, char *buf);

void SelectHostSocketEvent(void);
void SelectHostSocketEventEx(void);
void TcpHostTimer(void);

// ģݴ
void MapAnPointToHost(int iMapOutPort, int iMapSavePort);
void MapDiPointToHost(int iMapOutPort, int iMapSavePort);
void FormHostMapDataProce(int iMapOutPort, int iMapSavePort, HOSTMSG *msg);

// ȡǰû·ʶ
int  GetFendTxdFlag(void);

// жַǷǰûַ
int	CheckIsFendIpAddr(u_long addr);

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ǰûܺ
void WriteChangeData(int commidex, int point, void *pntmsg, BYTE type);
BOOL IsSendDatatoPort(int port);
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// ȡȫֱ
TCP_LINK_DEF *GetHostLinkPtr();
FEND_DEF *GetFendMsgPtr();
HOSTMSG *GetRtuChangeMsgPtr();

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ֽ˳ת
BOOL AllDataHostToRtuByteSequence(HOSTMSG *hmsg, ORTUMSG *pSendMsg);
BOOL AllDataRtuToHostByteSequence(HOSTMSG *hmsg);
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void SendSystemTimeToHost(void);
#endif
